//////////////////////////////////////////////////////////////////////
//
// LIBRARY FUNCTIONS
// Gĳsbert
//////////////////////////////////////////////////////////////////////

var MAXSPRITES=100;
var MAXBITMAPS=1000;

//////////////////////////////////////////////////////////////////////

var PSY_CENTRAL = -99999 ;

var MAX_FONTS = 100 ;
var psy_font_number  = 0 ; // only used during loading it seems
var psy_current_font = 1 ; // the currently set font with lines such as "font 1" ## counts from 1
var psy_fonts = new Array() ; // in this case, just like "20px Arial", as used by javascript/canvas
var psy_fonts_size = new Array() ; // in Javascript only (not PsyToolkit Java/C modes), the font size is stored in this global var

var PSY_VIDEO_DOUBLEBUFFER = 1 ; // this is the default and currently only option (TODO)

var PSY_KEY_STATUS_CORRECT = 1 ;
var PSY_KEY_STATUS_WRONG   = 2 ;
var PSY_KEY_STATUS_TIMEOUT = 3 ;

var psy_screen_center_x = 0 ;
var psy_screen_x_offset = 0 ;
var psy_screen_center_y = 0 ;
var psy_screen_y_offset = 0 ;
var psy_screen_width    = 800 ;
var psy_screen_height   = 600 ;
var psy_frame_w         = 800 ; // for the box in non-fullscreen mode. By default 800x600
var psy_frame_h         = 600 ;

var psy_bgcol_r         = 0 ; // default background color
var psy_bgcol_g         = 0 ;
var psy_bgcol_b         = 0 ;

var psy_exp_start_time = 0 ;
var psy_exp_current_time = 0 ;

var psy_blockorder = 1; // higher than 1 if more than one blockorder defined

//////////////////////////////////////////////////////////////////////
// some functions for dealing with current tasks (in C these are part
// of the task, here global variables)
var tablerow = 0 ;

//////////////////////////////////////////////////////////////////////
// some keyboard related variables

var keystatus = { key:0 , status: 0 , time: 0 , totaltime : 0 , mouse_x : 0 , mouse_y : 0 , bitmap: 0 }

var possiblekeys = new Array(); // this is the array used in all readkey functions

// TEST, new in 2.5.1-5 -- maybe move to different variable
var readkeys_option_size = 5 ; // default is 5
var readkeys_option_show = 1 ; // default letters are shown
var readkeys_option_show_x = 0 ; // default letters are shown at x
var readkeys_option_show_y = 0 ; // default letters are shown at x
var readkeys_option_font = 1 ; // default is first font (since 3.2.0 it is font 1)
var readkeys_option_placeholders = 0 ; // default is no placeholders
var readkeys_option_placeholder_bitmap = -1 ; // the bitmap of the placeholder to be used
var readkeys_option_placeholder_w = 0 ; // the bitmap of the placeholder rectangle width
var readkeys_option_placeholder_h = 0 ; // the bitmap of the placeholder rectangle height
var readkeys_option_spacing = -1 ; // the spacing of letters (for each letter, use 30 pixels). -1 is regular rendering
var readkeys_option_font_color = [255,255,255] ; // default color is white

var mousestatus = { key:0 , status: 0 , time: 0 , totaltime : 0 , x : 0 , y : 0 }

var rt_time_end_tasklist = null ; // only used in case of "maxtime" use at end of block

var psy_canvas=document.getElementById("exp"); // this is the canvas element
var canvas_x_offset = psy_canvas.getBoundingClientRect().left ; // used for getting correct mouse position
var canvas_y_offset = psy_canvas.getBoundingClientRect().top ; // because mouse position is relative to window, not elements

/// TODO -- can remove these from here once new keyboard code works

// moved key event listener from here
// window.addEventListener("keydown",getkeydown,true); // note the even listener works for whole web page... CHECK: does it need to be "true"
// window.addEventListener("keyup"  ,getkeyup  ,true); // note the even listener works for whole web page...

var psy_mouse_cursor = 0 ; // currently visible (1) or not (0)
var psy_mouse_store = 0 ; // tmp storage of mouse for pager and wait_key

var ctx=psy_canvas.getContext("2d");

// log stores log output which is helpful for debuggin, see function addlog()
var log = document.getElementById("log") ; // for debugging only

// in debug mode this is visible, otherwise this is a String variable being filled witht he user data
var output = document.getElementById("Output") ; 
outputdata = String()

var psy_bitmaps = new Array() ;
var psy_sounds  = new Array(); // for sound files
var psy_freqs   = new Array(); // for sound frequencies
var psy_freqs_number = 0; // the number of used frequencies in a trial

var psy_bitmaps_loaded = 0 ; // codes if bitmaps have been loaded (Javascript only)
var psy_sounds_loaded = 0 ; // codes if audio files have been loaded (Javascript only)
var psy_videos_loaded = 0 ; // codes if video (how many) files have been loaded (Javascript only)

var bmp_number = 0 ; //number of bitmaps loaded
var psy_video_number = 0 ; //number of videos read in so far (not necessarily loaded)
var psy_sound_number = 0 ; //number of bitmaps loaded

// there can only be one progress bar, and it has some additional info not stored in psy_stimuli1

var psy_pb = { // new in 2.7.0, the progressbar
    color1: [0,0,0],
    color2: [0,0,0],
    items1:0,
    items2:0,
    itemwidth: 0 ,
    between: 0,
    layout: 0 // 0=horizontal, 1=vertical
}

function psy_stimuli_loaded(){
    var percentage = 0 ;

    total_stimuli = bmp_number + psy_sound_number + psy_video_number
    total_loaded = psy_bitmaps_loaded + psy_sounds_loaded + psy_videos_loaded

    if ( total_stimuli > 0 )
	percentage = Math.round( total_loaded / total_stimuli * 100.0 ) ;
    else
	percentage = 100 ;

    tmp = (psy_bitmaps_loaded < bmp_number)||(psy_sounds_loaded < psy_sound_number)||(psy_videos_loaded < psy_video_number)

    if ( tmp && percentage < 100 ) return( percentage );
    if ( tmp && percentage == 100 ) return( 99 );
    if ( (psy_bitmaps_loaded == bmp_number) && (psy_sounds_loaded == psy_sound_number) && (psy_videos_loaded == psy_video_number))
	return( 100 );
}

// this function does not go on with <functionname> unless stimuli are
// loaded. It checks every second if stimulus loading has been
// completed

var stimuli_loader_indicator = 0 ; // 0 or 1

function when_stimuli_loaded_do ( functionname ){
    tmp = psy_stimuli_loaded() ;
    ctx.fillStyle = hexrgb(psy_bgcol_r,psy_bgcol_g,psy_bgcol_b);
    ctx.fillRect(0,0,psy_screen_width,psy_screen_height);
    ctx.font = "30px Arial";
    ctx.textAlign="left"

    // make sure loading text blinks so people see it is active
    if ( stimuli_loader_indicator == 0 ){
	ctx.fillStyle = "white" ;
	stimuli_loader_indicator = 1 ;
    }else{
	ctx.fillStyle = "green" ;
	stimuli_loader_indicator = 0 ;
    }

    if ( tmp < 100 ){
        if ( tmp == 0 )
	    ctx.fillText( psy_loading_text ,100,100);
	else
	    ctx.fillText( psy_loading_text+" "+tmp+"%",100,100);
	setTimeout( when_stimuli_loaded_do , 250 , functionname );
    }else{
	setTimeout( functionname , 0 );
    }
}

function psy_load_bitmap( name ){
    psy_bitmaps[ bmp_number ] = new Image() ;
    psy_bitmaps[ bmp_number ].onload = function(){ psy_bitmaps_loaded++ } ;
    psy_bitmaps[ bmp_number ].src = name ;
    bmp_number ++ ;
    return( bmp_number - 1 );
}

function psy_load_sound( name ){
    psy_sounds[ psy_sound_number ] = new Audio() ;
    psy_sounds[ psy_sound_number ].addEventListener("canplaythrough", function(){ psy_sounds_loaded++ } );
    psy_sounds[ psy_sound_number ].addEventListener("error", function(e) { this.load() } );
    psy_sounds[ psy_sound_number ].src = name ;
    psy_sounds[ psy_sound_number ].load() ; // new in 3.1.0 try out
    psy_sound_number ++ ;
    return( psy_sound_number - 1);
}

//--extra video variables and functions----------------------------------------------------
// note a number are already defined above, when inline with bitmaps and sounds

var psy_videos = new Array() ; // array of the the video class instances
var psy_videos_playing = 0 ; // how many movies are playing at same time

function psy_videos_loaded_call (e) { psy_videos_loaded ++ ; } // called by PsyVideo oncanplay

class PsyVideo{
    constructor( src ) {
	this.video = document.createElement("video");
	this.video.autoplay = false; // see https://rafenew.world/html5-video-oncanplay-oncanplaythrough-problem-firefox/
	this.video.addEventListener("canplaythrough", psy_videos_loaded_call );
	// this.video.addEventListener("error", function(){this.video.load()} ) // this is wrong, see correction next line
	this.video.addEventListener("error", () => {
	    console.error("Video loading error:", e);	    
	    console.error("Name of video in error:", this.video.src );	    
	    this.video.load();
	});

	this.video.src = src ;
	this.video.load();
	this.playing = false ;
    }

    play() {
	if ( this.playing == false ){
	    this.playing = true ;
	    this.video.play();
	    if ( psy_videos_playing == 0 ){
		requestAnimationFrame( psy_animation_updater );
		psy_videos_playing ++ ;
	    }
	}}
    
    pause() {
	this.video.pause();
    }

    unpause() {
	if ( this.video.paused ) this.video.play();
    }
    
    clear() {
	this.playing = false ;
	this.video.pause();
	this.video.currentTime = 0 ;
	psy_videos_playing -- ;
    }

    rewind() { this.video.currentTime = 0 ; }
    mute() {   this.video.muted = true ;    }
    unmute() { this.video.muted = false ;   }
    loop() {   this.video.loop = true ;     }
    once() {   this.video.loop = false ;    }
}

// function psy_animation_updater(){
//     for ( i=0 ; i < (psy_videos_loaded-1) ; i++ ){
// 	if ( psy_videos[i].playing == true ){
// 	    ctx.drawImage( psy_videos[i].video , psy_videos[i].realx , psy_videos[i].realy , psy_videos[i].w , psy_videos[i].h );
// 	}
//     }
//     if ( psy_videos_playing > 0 ) requestAnimationFrame( psy_animation_updater ) ;
// }

function psy_animation_updater(){
    for ( i=0 ; i < psy_stimuli1_end ; i++ ){
	// todo, need to think if internally I should count from zero
        // todo: check .on as well
	if ( psy_stimuli1[i].type == 5 && psy_videos[ psy_stimuli1[i].bitmap - 1 ].playing == true ){
	    ctx.drawImage( psy_videos[ psy_stimuli1[i].bitmap - 1 ].video , psy_stimuli1[i].rect.x , psy_stimuli1[i].rect.y , psy_stimuli1[i].rect.width , psy_stimuli1[i].rect.height );
	}
    }
    if ( psy_videos_playing > 0 ) requestAnimationFrame( psy_animation_updater ) ;
}

function psy_load_video( name ){
    psy_videos.push( new PsyVideo( name ) );
    psy_video_number ++ ;
    return( psy_video_number - 1);
}

// todo: psy_add_video might be more consistent with other new stimuli
function psy_play_video( number , x , y ){
    var tmpx ;

    // add new object
    psy_stimuli1[ psy_stimuli1_end ] = new psy_stimulus1 ;
    psy_stimuli1[ psy_stimuli1_end ].rect = new Rectangle ;

    /* if not yet playing, it is also a new stimulus */
    psy_stimuli1[ psy_stimuli1_end ].type = 5 ; /* 5 is movie */
    psy_stimuli1[ psy_stimuli1_end ].bitmap = number ; // use bitmap field for video number
    psy_stimuli1[ psy_stimuli1_end ].on = 1 ; // makes it active for psy_draw_all

    psy_stimuli1[ psy_stimuli1_end ].x = x ;
    psy_stimuli1[ psy_stimuli1_end ].y = y ; 

    // placement

    if ( x == PSY_CENTRAL )
        tmpx = psy_screen_center_x - psy_videos[number-1].video.videoWidth / 2 ;
    else
        tmpx = x + psy_screen_x_offset - psy_videos[number-1].video.videoWidth / 2 ;
    
    if ( y == PSY_CENTRAL )
        tmpy = psy_screen_center_y - psy_videos[number-1].video.videoHeight / 2 ;
    else
        tmpy = y + psy_screen_y_offset - psy_videos[number-1].video.videoHeight / 2 ;
    
    psy_stimuli1[ psy_stimuli1_end ].rect.x      = tmpx ;
    psy_stimuli1[ psy_stimuli1_end ].rect.y      = tmpy ;
    psy_stimuli1[ psy_stimuli1_end ].rect.width  = psy_videos[number-1].video.videoWidth ;
    psy_stimuli1[ psy_stimuli1_end ].rect.height = psy_videos[number-1].video.videoHeight ;

    // update counters

    psy_stimuli1_n ++ ;
    psy_stimuli1_end ++ ;
    psy_videos[ number - 1 ].play() ;
}

function psy_play_video_wh( number , x , y , w , h ){
    var tmpx ;

    // add new object
    psy_stimuli1[ psy_stimuli1_end ] = new psy_stimulus1 ;
    psy_stimuli1[ psy_stimuli1_end ].rect = new Rectangle ;

    /* if not yet playing, it is also a new stimulus */
    psy_stimuli1[ psy_stimuli1_end ].type = 5 ; /* 5 is movie */
    psy_stimuli1[ psy_stimuli1_end ].bitmap = number ; // use bitmap field for video number
    psy_stimuli1[ psy_stimuli1_end ].on = 1 ; // makes it active for psy_draw_all

    psy_stimuli1[ psy_stimuli1_end ].x = x ;
    psy_stimuli1[ psy_stimuli1_end ].y = y ; 

    // placement

    if ( x == PSY_CENTRAL )
        tmpx = psy_screen_center_x - w / 2 ;
    else
        tmpx = x + psy_screen_x_offset - w / 2 ;
    
    if ( y == PSY_CENTRAL )
        tmpy = psy_screen_center_y - h / 2 ;
    else
        tmpy = y + psy_screen_y_offset - h / 2 ;
    
    psy_stimuli1[ psy_stimuli1_end ].rect.x      = tmpx ;
    psy_stimuli1[ psy_stimuli1_end ].rect.y      = tmpy ;
    psy_stimuli1[ psy_stimuli1_end ].rect.width  = w ; 
    psy_stimuli1[ psy_stimuli1_end ].rect.height = h ;

    // update counters

    psy_stimuli1_n ++ ;
    psy_stimuli1_end ++ ;
    psy_videos[ number - 1 ].play();
}

function psy_play_video_scale( number , x , y , scale ){
    var tmpx ;

    // add new object
    psy_stimuli1[ psy_stimuli1_end ] = new psy_stimulus1 ;
    psy_stimuli1[ psy_stimuli1_end ].rect = new Rectangle ;

    /* if not yet playing, it is also a new stimulus */
    psy_stimuli1[ psy_stimuli1_end ].type = 5 ; /* 5 is movie */
    psy_stimuli1[ psy_stimuli1_end ].bitmap = number ; // use bitmap field for video number
    psy_stimuli1[ psy_stimuli1_end ].on = 1 ; // makes it active for psy_draw_all

    psy_stimuli1[ psy_stimuli1_end ].x = x ;
    psy_stimuli1[ psy_stimuli1_end ].y = y ; 

    // placement

    var tmpwidth = psy_videos[number-1].video.videoWidth * scale / 100 ;
    var tmpheight = psy_videos[number-1].video.videoHeight * scale / 100 ;

    if ( x == PSY_CENTRAL )
        tmpx = psy_screen_center_x - tmpwidth / 2 ;
    else
        tmpx = x + psy_screen_x_offset - tmpwidth / 2 ;
    
    if ( y == PSY_CENTRAL )
        tmpy = psy_screen_center_y - tmpheight / 2 ;
    else
        tmpy = y + psy_screen_y_offset - tmpheight / 2 ;
    
    psy_stimuli1[ psy_stimuli1_end ].rect.x      = tmpx ;
    psy_stimuli1[ psy_stimuli1_end ].rect.y      = tmpy ;
    psy_stimuli1[ psy_stimuli1_end ].rect.width  = tmpwidth ;
    psy_stimuli1[ psy_stimuli1_end ].rect.height = tmpheight ;

    // update counters

    psy_stimuli1_n ++ ;
    psy_stimuli1_end ++ ;
    psy_videos[ number - 1 ].play() ;
}

function psy_continue_video(number){psy_videos[ number - 1 ].unpause();}
function psy_pause_video( number ){psy_videos[ number - 1 ].pause();}
function psy_rewind_video( number ){ psy_videos[ number - 1 ].rewind();}
function psy_mute_video( number ){psy_videos[ number - 1 ].mute();}
function psy_unmute_video( number ){psy_videos[ number - 1 ].unmute();}
function psy_loop_video( number ){psy_videos[ number - 1 ].loop();}
function psy_once_video( number ){psy_videos[ number - 1 ].once();}

//--sound functions------------------------------------------------------------

function psy_play( sound , loop ){
    psy_sounds[ sound - 1 ].play();
    if ( loop == 1 ) psy_sounds[ sound - 1 ].loop = true ;
}


// psy_silence: negative numbers silence the frequencies
// positive numbers the sound files

function psy_silence( sound ){
    if ( sound >= 0 ){
	psy_sounds[ sound - 1 ].pause();
	psy_sounds[ sound - 1 ].currentTime = 0 ; // rewind
    }else{
	psy_freqs[ psy_freqs_number + sound ].stop()
    }
}

function psy_sound_pause( sound ){
    if ( sound >= 0 ){
	psy_sounds[ sound - 1 ].pause();
    }else{
	psy_freqs[ psy_freqs_number + sound ].stop()
    }
}

function psy_stop_freqs(){
    for ( i=0 ; i < psy_freqs_number ; i++ )
	psy_freqs[i].stop()
    psy_freqs_number = 0 ;
}

function psy_play_freq( type, hz , duration ){
    var context = new AudioContext()

    psy_freqs[ psy_freqs_number ] = context.createOscillator()
    psy_freqs[ psy_freqs_number ].type = type // type of wave, such as "sine"
    psy_freqs[ psy_freqs_number ].connect(context.destination)
    psy_freqs[ psy_freqs_number ].frequency.setValueAtTime( hz , context.currentTime);
    psy_freqs[ psy_freqs_number ].start()
    setTimeout( "psy_freqs[ "+psy_freqs_number+"].stop()" , duration )
    psy_freqs_number ++ ;
}

// in javascript, we currently only use browser based fonts, not real files
function psy_load_font( name , size ){
    psy_fonts[psy_font_number] = size+"pt "+name ;
    psy_fonts_size[psy_font_number] = size ;
    psy_font_number ++ ;
    return ( psy_font_number - 1 );
}

function addlog(text) {
    if ( log != null )
    {
	log.value += text + "\n";
        log.scrollTop = log.scrollHeight;
    }
}

function addoutput(text){
    if ( output != null ){ // in debug mode this is a textarea
	output.value += text+"\n";
	output.scrollTop = output.scrollHeight; // scrolls to bottom
    }
    outputdata = outputdata + text + "\n"
}

function hexrgb( r , g , b  ){
    h = "#"
    if ( r < 16 ) h=h+"0"+r.toString(16); else h=h+r.toString(16) ;
    if ( g < 16 ) h=h+"0"+g.toString(16); else h=h+g.toString(16) ;
    if ( b < 16 ) h=h+"0"+b.toString(16); else h=h+b.toString(16) ;
    return(h);
}

starttime = 0 ;

// note, Javascript passes by reference (i.e., pointers), so in the following, it actually works similary to C

// since 2.0.10 -> these need to be called in psy_keyboard (for "readkey")
function psy_expect_keyboard(){
    psy_readkey.expect_keyboard = true ;
    window.addEventListener("keydown",getkeydown,true); // note the even listener works for whole web page... CHECK: does it need to be "true"
    window.addEventListener("keyup"  ,getkeyup  ,true); // note the even listener works for whole web page...
    psy_readkey.keyupeventlistener = true ;
    psy_readkey.keydowneventlistener = true ;    
}

// this function need to be called (in psycc) in psy_keyboard_readkeys (for "readkeys")
function psy_expect_keyboard_readkeys(){
    psy_readkeys.expect_keyboard = true ;
    window.addEventListener("keydown",readkeys_keydown,true);
    window.addEventListener("keyup"  ,readkeys_keyup  ,true);
    psy_readkeys.keyupeventlistener = true ;
    psy_readkeys.keydowneventlistener = true ;    
}

function psy_expect_mouse(){ psy_readkey.expect_mouse = true ; }

function psy_keyboard( possiblekeys , nkeys, correctkey , maxtime ){
    psy_readkey.expectedkey = possiblekeys[ correctkey ];
    psy_readkey.keys = possiblekeys ;
    psy_expect_keyboard() ; // setup listeners
    psy_readkey.start( current_task , maxtime );
}

function psy_keyboard_readkeys( correct_word , maxtime ){
    psy_expect_keyboard_readkeys() ; // setup listeners
    psy_readkeys.correct_word = correct_word ;
    psy_readkeys.start( current_task , maxtime );
}

var psy_readkey = {
    lasttask: "",
    starttime: 0,
    readkeytimer: "",
    rt: 0,
    key: 0,
    status: 0,
    expect_keyboard: false,
    expect_mouse: false,
    expectedkey: 0,
    bitmap: 0, // if we are waiting for a mouse over bitmap event
    bitmap_range: [-1,-1] , // if we are waiting for a mouse key over a bitmap with a specific range of bitmap numbers
    array_search: false , // new in 3.2.0 -> only true if search for stimulus within range set by array
    mouseovereventlistener: 0, // this helps to remove non-needed high resource demanding eventlistener; 0,1,2
    mousedowneventlistener: false, // this helps to remove non-needed high resource demanding eventlistener
    keyupeventlistener: false,
    keydowneventlistener: false,

    start: function(task, maxtime ) {
        psy_readkey.rt = maxtime; // if it never gets changed, it means all time has been used
        psy_readkey.key = 0;
        psy_readkey.starttime = new Date().getTime();
        psy_readkey.lasttask = task;
        psy_readkey.readkeytimer = setTimeout( "psy_readkey.timeout()", maxtime); 
        keystatus.status = 3; // assume timeout, will be changed in getkey
	keystatus.bitmap = -1 ; // the bitmap under cursor, if in some mouse function (since 2.3.6)
        keystatus.time = maxtime; // assume timeout, will be changed in getkey; // if it never gets changed, it means all time has been used
        keystatus.key = 0; // assume timeout, will be changed in getkey
        // addlog("in psy_readkey -- expect_boardkey: " + psy_readkey.expect_keyboard); //DEBUG
    },

    stop: function() {
        // addlog("stop readkey__") //DEBUG
        clearTimeout(psy_readkey.readkeytimer);
        psy_readkey.expect_keyboard = false; // insurance, this is already done in getkey/getmouse
        psy_readkey.expect_mouse = false; // insurance, this is already done in getkey/getmouse	
	if ( psy_readkey.mouseovereventlistener == 1 ){
	    window.removeEventListener("mousemove",getmouse_in_area,false) ; 
	    psy_readkey.mouseovereventlistener = 0 ; 
	}
	if ( psy_readkey.mouseovereventlistener == 2 ){
	    window.removeEventListener("mousemove",getmouse_in_area_check_all,false) ; 
	    psy_readkey.mouseovereventlistener = 0 ; 
	}
	if ( psy_readkey.mousedowneventlistener == true ){
	    window.removeEventListener("mousemove",getmouse_track,false) ; // new in 3.4.1
	    window.removeEventListener("mousedown",getmouseclick_in_area,false) ; 
	    psy_readkey.mousedowneventlistener = false ;
	}
	if ( psy_readkey.keyupeventlistener == true ){
	    window.removeEventListener("keyup",getkeyup,false) ; 
	    psy_readkey.keyupeventlistener = false ;
	}
	if ( psy_readkey.keydowneventlistener == true ){
	    window.removeEventListener("keydown",getkeydown,false) ; 
	    psy_readkey.keydowneventlistener = false ;
	}
        eval(psy_readkey.lasttask + ".run()"); // started using this again in 3.3.0, might be faster and seems to work well
	// setTimeout(psy_readkey.lasttask + ".run()",0);	
    },

    timeout: function(){
        //addlog("stop readkey because of timeout") //DEBUG
        psy_readkey.expect_keyboard = false;
        psy_readkey.expect_mouse = false;	
	if ( psy_readkey.mouseovereventlistener == true ){
	    window.removeEventListener("mousemove",getmouse_in_area,false) ; 
	    psy_readkey.mouseovereventlistener = false 
	}
	if ( psy_readkey.mousedowneventlistener == true ){
	    window.removeEventListener("mousemove",getmouse_track,false) ; // new in 3.4.1
	    window.removeEventListener("mousedown",getmouseclick_in_area,false) ; 
	    psy_readkey.mousedowneventlistener = false 
	}
        eval(psy_readkey.lasttask + ".run()");
    },
    timeout_end_tasklist: function() { // emergency break
	if (psy_readkey.expect_keyboard == true || psy_readkey.expect_mouse == true )
	    eval( "psy_readkey.timeout()" );
    }
}

// -------------------------------------------------------------------

var psy_drag = {
    lasttask: "",
    timer: 0 , // for the timeout/maxrt
    starttime: 0,
    fromarray: [], // the possible stimuli that can be dragged
    onarray: [], // the possible stimuli that can be dragged on (if given)
    stimulus: 0, // the stimulus # being dragged
    stimulus_old_x: 0, // you need this, in case position needs to be set back
    stimulus_old_y: 0,
    x: 0, // latest x,y coordinates of stimulus
    y: 0,
    stimulus_copy: 0, // the stimulus copy for "actual" dragging
    changed: 0 , // for later use, so we know drag changed things 0=false,1=true
    on: 0 , // the stimulus dragged on (or 0 if none)
    snap: false, // center on top of other stimulus
    ghost: false, // do not move stimulus, but instead add stimulus copy and move
    dragging: false, // when in "dragging" (not simple drag)
    exit: 0, // when in "dragging", the exit stimulus number
    maxrt: 0,
    mousedowneventlistener: false,
    mouseupeventlistener: false,
    mousemoveeventlistener: false,
    xlim: [-9999,9999],
    ylim: [-9999,9999],
    align_x: 0, // no,left,center,right (1,2,3)
    align_y: 0, // no,top,center,bottom (1,2,3)
    align_o: 0, // (no) overlap=0/1
    noa: [],    // if given, the array of stimuli that snap will not overlap with
    xstack: 0, // -1=to left, 0=no, 1=to right (see log for details)
    ystack: 0, // -1=to top, 0=no, 1=to right
    
    stop: function(){
	if ( psy_drag.mousedowneventlistener ) window.removeEventListener("mousedown",getmousedowndrag,false) ; 
	if ( psy_drag.mouseupeventlistener ) window.removeEventListener("mouseup",getmouseupdrag,false) ; 
	if ( psy_drag.mousemoveeventlistener ) window.removeEventListener("mousemove",getmousemovedrag,false) ; 
	psy_drag.mousedowneventlistener = false ;
	psy_drag.mouseupeventlistener = false ;
	psy_drag.mousemoveeventlistener =  false ;
    },
    timeout: function(){ // only called if dragging not finished
	psy_drag.stop();
	keystatus.status = 3 ; // use psy_readykey for STATUS
	keystatus.time = psy_drag.maxrt ; // use psy_readykey for RT
	// in case it was already moved a bit
	if ( psy_drag.stimulus > 0 ){
	    psy_canvas.style.cursor = "default"
	    if (psy_stimuli1[psy_drag.stimulus - 1].x == psy_drag.stimulus_old_x && psy_stimuli1[psy_drag.stimulus - 1].y == psy_drag.stimulus_old_y ){
		psy_relocate_existing_stimulus( psy_drag.stimulus , psy_drag.stimulus_old_x , psy_drag.stimulus_old_y );
		psy_draw_all_db();
	    }
	}
	setTimeout( current_task+".run()" , 0 )
    },
    run_dragging: function(){
	// you get back here once one drag has been finished, that is, for each drag withing a run_dragging call
	// only by setting psy_drag.dragging to false, you will return to the task
	if ( psy_drag.dragging == false ){
	    psy_drag.stop();
	    // TODO, does anything else need to be done (note: timer is already switched off elsewhere)
	    setTimeout( current_task+".run()" , 0 ) // return back to task once the exit has been set or the timeout has been reached
	}else{
	    psy_drag.mousedowneventlistener=true;
	    window.addEventListener("mousedown",getmousedowndrag,false);	    
	}
    },
    timeout_dragging: function(){
	// this is called by the timer in case the exit button was not called
	psy_drag.dragging = false ;
	psy_drag.timeout(); // rest done by timeout()
    }
}

// when mouse is pressed down during "drag" instruction
function getmousedowndrag(e){
    canvas_x_offset = psy_canvas.getBoundingClientRect().left ;
    canvas_y_offset = psy_canvas.getBoundingClientRect().top ;
    canvas_w = psy_canvas.getBoundingClientRect().width;
    canvas_h = psy_canvas.getBoundingClientRect().height;

    // new in 3.3.2, scale
    tmpmouseX = Math.round( ( e.clientX - canvas_x_offset ) * psy_screen_width / canvas_w ) ;
    tmpmouseY = Math.round( ( e.clientY - canvas_y_offset ) * psy_screen_height / canvas_h ) ;

    // check if current click is on one of the possible stimuli

    var tmpbitmap = psy_bitmap_under_mouse_in_range( psy_drag.fromarray ,
						     tmpmouseX - psy_screen_x_offset ,
						     tmpmouseY - psy_screen_y_offset )

    if ( psy_drag.dragging == true && tmpbitmap == psy_drag.exit ){
	clearTimeout( psy_drag.timer ) ; // stop the timeout timer
	psy_drag.dragging = false ;

	// note, the event listener will be stopped, because run_dragging will stop it through its stop function
	setTimeout( psy_drag.run_dragging , 0 ); // after this call, "dragging" will stop. TODO: THIS MIGHT EVEN SIMPLY RETURN TO current_task()
    }else{
	if ( tmpbitmap > 0 ){ // if one of the stimuli in fromarray was selected, start the "moving" part of drag

	    // actually, we create a new stimulus and drag that one
	    psy_drag.stimulus_copy = psy_copy_stimulus( tmpbitmap );

	    // we store the to be moved stimulus coordinates for later use
	    psy_drag.stimulus_old_x = psy_stimuli1[ tmpbitmap - 1].x ;
	    psy_drag.stimulus_old_y = psy_stimuli1[ tmpbitmap - 1].y ;

	    // we remove the "old" stimulus from screen
	    psy_clear_stimuli1( tmpbitmap );
	    
	    psy_canvas.style.cursor = "move"
	    
	    psy_drag.stimulus = tmpbitmap ; // we need to remember the original stimulus number

	    // now we are ready to wait for mousemove and mouseup events
	    window.addEventListener("mousemove",getmousemovedrag,false) ;
	    window.addEventListener("mouseup",getmouseupdrag,false) ;
	    
	    psy_drag.mousemoveeventlistener= true;
	    psy_drag.mouseupeventlistener= true;

	    // stop the mousedown eventlistener
	    window.removeEventListener("mousedown",getmousedowndrag,false) ; 
	    psy_drag.mousedowneventlistener=false;
	}
    }

    // note: if the tmpbitmap was zero, the eventlistener will keep listening.
    // this is important, especially because at start, the mouse might have been down and that is why
    // the tmpbitmap was zero
}

// when mouse is released during "drag" instruction
function getmouseupdrag(e){
    keystatus.time = new Date().getTime() - psy_drag.starttime  ; // set the total time
    psy_canvas.style.cursor = "default"
    window.removeEventListener("mousemove",getmousemovedrag,false) ; 
    window.removeEventListener("mouseup",getmouseupdrag,false) ; 
    psy_drag.mousemoveeventlistener= false;
    psy_drag.mouseupeventlistener= false;

    if ( psy_drag.dragging == false ) clearTimeout( psy_drag.timer ) ; // in "dragging", the timer will keep going

    if ( psy_drag.toarray.length > 0 ){ // can only drag to specific set of stimuli
	if ( psy_drag.stimulus > 0 ){
	    // replace the new actually drag stimulus with old one, and delete new one
	    psy_stimuli1[ psy_drag.stimulus - 1 ] = Object.assign({},psy_stimuli1[ psy_drag.stimulus_copy - 1 ] );
	    psy_stimuli1_n ++ ; // you just added a visible stimulus
	    psy_delete_last_stimulus();

	    // check where mouse is
	    canvas_x_offset = psy_canvas.getBoundingClientRect().left ;
	    canvas_y_offset = psy_canvas.getBoundingClientRect().top ;	    
	    canvas_w = psy_canvas.getBoundingClientRect().width;
	    canvas_h = psy_canvas.getBoundingClientRect().height;

	    tmpmouseX = Math.round( ( e.clientX - canvas_x_offset ) * psy_screen_width / canvas_w ) - psy_screen_x_offset ;
	    tmpmouseY = Math.round( ( e.clientY - canvas_y_offset ) * psy_screen_height / canvas_h ) - psy_screen_y_offset ;

	    // save data for possible use in MOUSE_X/Y	    
	    keystatus.mouse_x = tmpmouseX ; //TODO, why then use even tmpmouseX??? Can just use this variable
	    keystatus.mouse_y = tmpmouseY ;

	    // determine stimulus underneath mouse, except for this stimulus
	    var tmparray = psy_array_remove_value( Array.from(psy_drag.toarray) , psy_drag.stimulus )
	    psy_drag.on = psy_bitmap_under_mouse_in_range( tmparray , tmpmouseX , tmpmouseY );

	    // now check if tmpbitmap can be found in the range
	    if ( psy_drag.on > 0 ){
		// if snap, now we need to check if snap is needed and then snap it
		// TODO: We could not do snap if stimulus is already exactly on stimulus, but that is unlikely to be so exact
		if ( psy_drag.align_x == 1 ) psy_drag.xstack = 1 ; // stack to right
		if ( psy_drag.align_x == 3 ) psy_drag.xstack = -1 ; // stack to left
		if ( psy_drag.align_y == 1 ) psy_drag.ystack = 1 ; // stack to right
		if ( psy_drag.align_y == 3 ) psy_drag.ystack = -1 ; // stack to left

		// make sure to remove psy_drag.stimulus from psy_drag.noa

		psy_stimuli_align( psy_drag.stimulus , psy_drag.on , psy_drag.align_x , psy_drag.align_y , psy_drag.align_o , psy_array_remove_value( psy_drag.noa , psy_drag.stimulus) , psy_drag.xstack , psy_drag.ystack );
		psy_draw_all_db();
		
		keystatus.status = 1 ; // use psy_readykey for STATUS
	    }else{
		keystatus.status = 2 ; // use psy_readykey for STATUS
	    }
	    psy_drag.changed = 1 ; // this way, user can find out stimulus has been moved
	}else{ // this means, no stimulus was selected, so we get TIMEOUT
	    keystatus.status = 3 ; // use psy_readykey for STATUS
	}

    }else{ // no "drag to" specified, which is easier
	if ( psy_drag.stimulus > 0 ){
	    // save data for possible use in MOUSE_X/Y
	    canvas_x_offset = psy_canvas.getBoundingClientRect().left ;
	    canvas_y_offset = psy_canvas.getBoundingClientRect().top ;	    
	    keystatus.mouse_x = e.clientX - canvas_x_offset - psy_screen_x_offset ;
	    keystatus.mouse_y = e.clientY - canvas_y_offset - psy_screen_y_offset ;

	    // replace the new actually drag stimulus with old one, and delete new one
	    // note that this stimulus number was previously cleared
	    psy_stimuli1[ psy_drag.stimulus - 1 ] = Object.assign({},psy_stimuli1[ psy_drag.stimulus_copy - 1 ] );
	    psy_stimuli1_n ++ ; // you just added a visible stimulus

	    psy_delete_last_stimulus(); // delete the temporary top stimulus we created with psy_stimulus_copy()

	    // now set psy_drag changed
	    if (psy_stimuli1[psy_drag.stimulus - 1].x != psy_drag.stimulus_old_x || psy_stimuli1[psy_drag.stimulus - 1].y != psy_drag.stimulus_old_y ){psy_drag.changed = 1 ; }
	}
	// set vars
	keystatus.status = 1 ; // use psy_readykey for STATUS
    }

    // move stimulus back to original location in case it was move and status was not correct
    if ( psy_drag.stimulus > 0 && keystatus.status != 1 ){
	if (psy_stimuli1[psy_drag.stimulus - 1].x != psy_drag.stimulus_old_x || psy_stimuli1[psy_drag.stimulus - 1].y == psy_drag.stimulus_old_y ){
	    psy_drag.changed = 1 ;
	    psy_relocate_existing_stimulus( psy_drag.stimulus , psy_drag.stimulus_old_x , psy_drag.stimulus_old_y );
	    psy_draw_all_db();
	}
    }

    // now return back to the task
    if ( psy_drag.dragging )
	setTimeout( psy_drag.run_dragging , 0 ); // When dragging, the psy_drag.dragging function keeps asking for another drag
    else
	setTimeout( psy_drag.lasttask+".run()" , 0 ); // TODO: CAN THIS NOT JUST BE "current_task?"
}

// when mouse is "moving" during "drag" instruction
function getmousemovedrag(e){
    canvas_x_offset = psy_canvas.getBoundingClientRect().left ;
    canvas_y_offset = psy_canvas.getBoundingClientRect().top ;
    canvas_w = psy_canvas.getBoundingClientRect().width;
    canvas_h = psy_canvas.getBoundingClientRect().height;

    tmpmouseX = Math.round( ( e.clientX - canvas_x_offset ) * psy_screen_width / canvas_w ) - psy_screen_x_offset ;
    tmpmouseY = Math.round( ( e.clientY - canvas_y_offset ) * psy_screen_height / canvas_h ) - psy_screen_y_offset ;

    // note, a copy is actually being dragged
    if ( tmpmouseX < psy_drag.xlim[0] ) tmpmouseX = psy_drag.xlim[0] ;
    if ( tmpmouseX > psy_drag.xlim[1] ) tmpmouseX = psy_drag.xlim[1] ;
    if ( tmpmouseY < psy_drag.ylim[0] ) tmpmouseY = psy_drag.ylim[0] ;
    if ( tmpmouseY > psy_drag.ylim[1] ) tmpmouseY = psy_drag.ylim[1] ;

    psy_drag.x = tmpmouseX ;
    psy_drag.y = tmpmouseY ;

    psy_relocate_existing_stimulus( psy_drag.stimulus_copy , tmpmouseX , tmpmouseY );
    psy_draw_all_db()
}

// -------------------------------------------------------------------

var psy_readkeys = {
    x:0,y:0, // for position of letters if given
    expect_keyboard: false, // redundant but useful insurance
    keyspressed: [], // all of the the specific keys pressed in time
    lasttask: "",
    starttime: 0,
    readkeytimer: "",
    rt: 0,
    rts: [], // each time key is pressed, record RT since start here
    key: 0,
    keys: [],
    current_position: 0, // which letter position being typed in, starts with 0
    bitmap_number: [], // for each position, you have a bitmap, unless you use regular rendering (then you have just 1)
    status: 0,
    entered: "", // will contain the asciicodes of possible keys
    correct_word: "",
    keyupeventlistener: false,
    keydowneventlistener: false,

    start: function(task, maxtime) {
	// set the start x/y location of the word
	psy_readkeys.x = readkeys_option_show_x ;
	psy_readkeys.y = readkeys_option_show_y ;
	// reset some values
	psy_readkeys.current_position = 0 ;
	psy_readkeys.entered = "" ;
	this.bitmap_number.length = 0 ; // needed at start (resets array)
	// if needed draw placeholders
	if ( readkeys_option_placeholders == 1 ){
	    if ( readkeys_option_placeholder_bitmap >= 0 ){
		for( p=0;p<readkeys_option_size;p++ )
		    psy_add_centered_bitmap_db( readkeys_option_placeholder_bitmap , 
						psy_readkeys.x + p*50 , psy_readkeys.y , 0 );
	    }else{
	    if ( readkeys_option_placeholder_bitmap == -1 ){
		for( p=0;p<readkeys_option_size;p++ )
		    psy_add_centered_rectangle_rgb_db( psy_readkeys.x + p*readkeys_option_spacing , psy_readkeys.y , 
						       readkeys_option_placeholder_w,
						       readkeys_option_placeholder_h,
						       100,100,255 );
	    }
	    }
	    psy_draw_all_db();
	}

        psy_readkeys.rt = maxtime; // if it never gets changed, it means all time has been used
	psy_readkeys.rts = [] ; // each RT since starttime will be noted
	psy_readkeys.keys = [] ; // each individual key including backspace will be recorded
        psy_readkeys.starttime = new Date().getTime();
        psy_readkeys.lasttask = task;
        psy_readkeys.readkeytimer = setTimeout( "psy_readkeys.timeout()", maxtime); 
        keystatus.status = 3; // assume timeout, will be changed in getkey
        keystatus.time = maxtime; // assume timeout, will be changed in getkey; // if it never gets changed, it means all time has been used
    },

    stop: function() {
	// check status
	if ( psy_readkeys.entered == psy_readkeys.correct_word ) keystatus.status = 1 ;
	if ( psy_readkeys.entered != psy_readkeys.correct_word ) keystatus.status = 2 ;
	// now clear timers
        clearTimeout(psy_readkeys.readkeytimer);
        psy_readkeys.expect_keyboard = false; // insurance, this is already done in getkey/getmouse
	if ( psy_readkeys.keyupeventlistener == true ){
	    window.removeEventListener("keyup",readkeys_keyup,false) ; 
	    psy_readkeys.keyupeventlistener = false ;
	}
	if ( psy_readkeys.keydowneventlistener == true ){
	    window.removeEventListener("keydown",readkeys_keydown,false) ; 
	    psy_readkeys.keydowneventlistener = false ;
	}
	setTimeout(psy_readkeys.lasttask + ".run()",0);	
    },

    timeout: function(){
        psy_readkeys.expect_keyboard = false;
	setTimeout(psy_readkeys.lasttask + ".run()",0);	
    }
}

// ----------------------------------------------------------------------

var pager_options = { // for use in psy_mouse_pager
    back: 0, backX: 0, backY: 0 ,
    next: 0, nextX: 0, nextY: 0 ,
    quit: 0, quitX: 0, quitY: 0
}

var inkeypress=0 // used for key listeners

function getkeydown( e ){
    //addlog("EVENT") //DEBUG
    // if ( e.keyCode == 27 ) { e.preventDefault() ; e.stopPropagation() ; }
    
    inkeypress++ // prevent people holding the key (only inkeypress == 1 is valid)

    // in the next line, check if a keypress is being expected, if we are in a keypress situation, and if the key code is
    // of the allowed keys

    if ( psy_readkey.expect_keyboard == true && inkeypress==1 && psy_readkey.keys.indexOf(e.keyCode) > -1 )
    {
	keystatus.time = new Date().getTime() - psy_readkey.starttime ;
	keystatus.key = psy_readkey.keys.indexOf(e.keyCode) ;

	if ( e.keyCode == psy_readkey.expectedkey ){
	    keystatus.status = 1
	    //addlog("correct key") //DEBUG
	}
	else {
	    keystatus.status = 2
	    //addlog("wrong key") //DEBUG
	}

	psy_readkey.expect_keyboard = false ;
	psy_readkey.stop();
	
	// addlog("key pressed") //DEBUG
    }
    else
    {
	inkeypress = 0
	// addlog("key pressed but not expected right now, or a non allowed key was pressed which will be ignored entirely") //DEBUG
    }
}

function getkeyup(e){
    // if ( e.keyCode == 27 ) { e.preventDefault() ; e.stopPropagation() ; }
    
    if ( inkeypress == 1 ){
	keystatus.totaltime = new Date().getTime() - psy_readkey.starttime ;
    }
    inkeypress = 0
}

// now similar window listening functions for readkeys

function readkeys_keydown( e ){
    inkeypress++ // prevent people holding the key (only inkeypress == 1 is valid)

    // in the next line, check if a keypress is being expected, if we are in a keypress situation, and if the key code is
    // of the allowed keys

    // if ( psy_readkeys.expect_keyboard == true && inkeypress==1 )
    if ( psy_readkeys.expect_keyboard == true )
    {
	keystatus.time = new Date().getTime() - psy_readkeys.starttime ;
	psy_readkeys.rts.push( keystatus.time )
	psy_readkeys.keys.push( e.key )

	switch( e.keyCode )
	{
	    case 8: // backspace
	    e.preventDefault();	    
	    if ( psy_readkeys.current_position > 0 ){
		psy_readkeys.current_position-- ;
		psy_readkeys.entered = psy_readkeys.entered.slice(0,psy_readkeys.current_position) ;
		if ( readkeys_option_show == 1 ){
		    if ( readkeys_option_spacing >= 0 ){
			psy_clear_stimuli1( psy_readkeys.bitmap_number[ psy_readkeys.current_position ] );
		    }else{ // TODO: this will unlikely be the first key, but it is not impossible
			if ( psy_readkeys.bitmap_number.length == 0 ){ // first drawing of the word
			    psy_add_text_rgb_db( readkeys_option_font ,
						 psy_readkeys.x ,
						 psy_readkeys.y ,
						 PSY_CENTRAL,PSY_CENTRAL,
						 readkeys_option_font_color[0],
						 readkeys_option_font_color[1],
						 readkeys_option_font_color[2],
						 psy_readkeys.entered , 1 );
			}else{ // this is if you do rendering of whole word at once
			    psy_change_text_rgb_db( psy_readkeys.bitmap_number[0] , readkeys_option_font ,
						    psy_readkeys.x ,
						    psy_readkeys.y ,
						    PSY_CENTRAL,PSY_CENTRAL,
						    readkeys_option_font_color[0],
						    readkeys_option_font_color[1],
						    readkeys_option_font_color[2],
						    psy_readkeys.entered , 1 );
			}
		    }
		    psy_draw_all_db(); // for both methods
		}
	    }

	    break;

	    case 13: // return
	    psy_readkeys.expect_keyboard = false ;
	    psy_readkeys.stop();
	    break;

	    case 16: // shift -- do nothing
	    if ( readkeys_option_show == 1 ) psy_draw_all_db();
	    break;

	    case 17: // control -- do nothing
	    if ( readkeys_option_show == 1 ) psy_draw_all_db();
	    break;

	    case 18: // alt -- do nothing
	    if ( readkeys_option_show == 1 ) psy_draw_all_db();
	    break;

	    case 20: // caps lock -- do nothing
	    if ( readkeys_option_show == 1 ) psy_draw_all_db();
	    break;

	    case 27: // Escape -- do nothing
	    if ( readkeys_option_show == 1 ) psy_draw_alldb();
	    break;

	    case 46: // Escape -- do nothing
	    if ( readkeys_option_show == 1 ) psy_draw_all_db();
	    break;

	    case 144: // NumLock -- do nothing
	    if ( readkeys_option_show == 1 ) psy_draw_all_db();
	    break;

	    default:
	    if ( psy_readkeys.current_position < readkeys_option_size ){
		// psy_readkeys.entered = psy_readkeys.entered+String.fromCharCode( e.keyCode ) ; OLD
		tmpchar = e.key

		if ( tmpchar.length == 1 )
                    psy_readkeys.entered = psy_readkeys.entered + e.key ;
                else {
                    psy_readkeys.entered = psy_readkeys.entered + "?" ;
		    tmpchar = "?"
		}
		    
		// now draw the stimuli if needed
		// note you need to keep the bitmap numbers so that you can delete them if needed with "del"
		if ( readkeys_option_show == 1 ){
		    if ( readkeys_option_spacing >= 0 ){
		    psy_readkeys.bitmap_number[ psy_readkeys.current_position ] =
			psy_add_text_rgb_db( readkeys_option_font ,
					     psy_readkeys.x + psy_readkeys.current_position * readkeys_option_spacing ,
					     psy_readkeys.y ,
					     PSY_CENTRAL,PSY_CENTRAL,
					     readkeys_option_font_color[0],
					     readkeys_option_font_color[1],
					     readkeys_option_font_color[2],
					     tmpchar , 0 );
					     //String.fromCharCode( e.keyCode ) , 0 );
		    }else{ // the readkeys_option_spacing == -1, render the whole word
			if ( psy_readkeys.bitmap_number.length == 0 ){ // first drawing of the word
			psy_readkeys.bitmap_number[ 0 ]= psy_add_text_rgb_db( readkeys_option_font ,
					     psy_readkeys.x ,
					     psy_readkeys.y ,
					     PSY_CENTRAL,PSY_CENTRAL,
					     readkeys_option_font_color[0],
					     readkeys_option_font_color[1],
					     readkeys_option_font_color[2],
					     psy_readkeys.entered , 1 ); // note that "align=1"
			}else{
			    psy_change_text_rgb_db( psy_readkeys.bitmap_number[0] , readkeys_option_font ,
						 psy_readkeys.x ,
						 psy_readkeys.y ,
						 PSY_CENTRAL,PSY_CENTRAL,
						 readkeys_option_font_color[0],
						 readkeys_option_font_color[1],
						 readkeys_option_font_color[2],
						 psy_readkeys.entered , 1 );
			    
			}
		    }

		    psy_draw_all_db();
		    psy_readkeys.current_position++ ;
		}
	    }
	}
    }
    else
    {
	inkeypress = 0
    }
}

function readkeys_keyup(e){
    // if ( e.keyCode == 27 ) { e.preventDefault() ; e.stopPropagation() ; }
    
    if ( inkeypress == 1 && e.keyCode != 13 ){
	keystatus.totaltime = new Date().getTime() - psy_readkeys.starttime ;
    }
    inkeypress = 0
}

// this function returns if the psy_readkey.bitmap has been hovered over.
// see also getmouse_in_area_check_all for checking other stimuli as well

function getmouse_in_area( e ){ // http://livecoding.io/3887542
    if ( psy_readkey.expect_mouse == true ){

	/* following two lines are important because mouse position is
	 * relative to browser "window", not "canvas" */
	canvas_x_offset = psy_canvas.getBoundingClientRect().left ;
	canvas_y_offset = psy_canvas.getBoundingClientRect().top	    
	canvas_w = psy_canvas.getBoundingClientRect().width;
	canvas_h = psy_canvas.getBoundingClientRect().height;

	// new in 3.3.2, scale
	tmpmouseX = Math.round( ( e.clientX - canvas_x_offset ) * psy_screen_width / canvas_w ) ;
	tmpmouseY = Math.round( ( e.clientY - canvas_y_offset ) * psy_screen_height / canvas_h ) ;

	if ( tmpmouseX >= psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.x &&
             tmpmouseX <= psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.x+psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.width &&
	     tmpmouseY >= psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.y &&
             tmpmouseY <= psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.y+psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.height ){
	    keystatus.time = new Date().getTime() - psy_readkey.starttime ;
	    keystatus.status = 1 ;
	    keystatus.mouse_x = tmpmouseX - psy_screen_x_offset ; // save this in psytoolkit coordinates
	    keystatus.mouse_y = tmpmouseY - psy_screen_y_offset ; 
	    psy_readkey.expect_mouse = false ;
	    psy_readkey.stop() ;
	    // addlog("Mouse moved in area.")
	}
    }
}

function getmouse_track( e ){ // similar to hover, used when waiting for click -- new in 3.4.1
    if ( psy_readkey.expect_mouse == true ){

	/* following two lines are important because mouse position is
	 * relative to browser "window", not "canvas" */
	canvas_x_offset = psy_canvas.getBoundingClientRect().left ;
	canvas_y_offset = psy_canvas.getBoundingClientRect().top	    
	canvas_w = psy_canvas.getBoundingClientRect().width;
	canvas_h = psy_canvas.getBoundingClientRect().height;

	tmpmouseX = Math.round( ( e.clientX - canvas_x_offset ) * psy_screen_width / canvas_w ) ;
	tmpmouseY = Math.round( ( e.clientY - canvas_y_offset ) * psy_screen_height / canvas_h ) ;

	keystatus.mouse_x = tmpmouseX - psy_screen_x_offset ; // save this in psytoolkit coordinates
	keystatus.mouse_y = tmpmouseY - psy_screen_y_offset ; 
    }
}

function getmouse_in_area_check_all( e ){ // http://livecoding.io/3887542
    if ( psy_readkey.expect_mouse == true ){

	/* following two lines are important because mouse position is
	 * relative to browser "window", not "canvas" */
	canvas_x_offset = psy_canvas.getBoundingClientRect().left ;
	canvas_y_offset = psy_canvas.getBoundingClientRect().top	    
	canvas_w = psy_canvas.getBoundingClientRect().width;
	canvas_h = psy_canvas.getBoundingClientRect().height;

	// new in 3.3.2, scale
	tmpmouseX = Math.round( ( e.clientX - canvas_x_offset ) * psy_screen_width / canvas_w ) ;
	tmpmouseY = Math.round( ( e.clientY - canvas_y_offset ) * psy_screen_height / canvas_h ) ;

	var found = false , i = 0 ;
	var range1 = 0 ;
	var range2 = psy_stimuli1_end - 1 ;

	if ( psy_readkey.bitmap_range[0] > -1 ) range1 = psy_readkey.bitmap_range[0] - 1 ;
	if ( psy_readkey.bitmap_range[1] > -1 ) range2 = psy_readkey.bitmap_range[1] - 1 ;

	while( i < psy_stimuli1_end && found == false ){
	    if ( psy_stimuli1[i].on == 1 && i >= range1 && i <= range2 ){
		if ( tmpmouseX >= psy_stimuli1[ i ].rect.x &&
		     tmpmouseX <= psy_stimuli1[ i ].rect.x+psy_stimuli1[ i ].rect.width &&
		     tmpmouseY >= psy_stimuli1[ i ].rect.y &&
		     tmpmouseY <= psy_stimuli1[ i ].rect.y+psy_stimuli1[ i ].rect.height ){

		    found = true ;
		    keystatus.time = new Date().getTime() - psy_readkey.starttime ;
		    psy_readkey.expect_mouse = false ;
		    keystatus.mouse_x = tmpmouseX - psy_screen_x_offset ; // save this in psytoolkit coordinates
		    keystatus.mouse_y = tmpmouseY - psy_screen_y_offset ; 
		    if ( ( psy_readkey.bitmap - 1 ) == i ) keystatus.status = 1 ;
		    if ( ( psy_readkey.bitmap - 1 ) != i ) keystatus.status = 2 ;
		    psy_readkey.stop(); // this escapes us out of this function?
		}
	    }
	    i=i+1 ;
	}
    }
}

function getmouseclick_in_area( e ){ // http://livecoding.io/3887542

    // this function only runs if mouse has been clicked.
    // e.button->0 is left and 1 is right

    // there are three ways to do this
    // case 1: there is no range of bitmaps to look for bitmap_range=[-1,-1]
    // it will just check if the mouse is in the area of the requested bitmap or not
    if ( psy_readkey.expect_mouse == true && psy_readkey.bitmap_range[1] == -1 ){
	keystatus.time = new Date().getTime() - psy_readkey.starttime ;

	canvas_x_offset = psy_canvas.getBoundingClientRect().left ;
	canvas_y_offset = psy_canvas.getBoundingClientRect().top	    
	canvas_w = psy_canvas.getBoundingClientRect().width;
	canvas_h = psy_canvas.getBoundingClientRect().height;

	// new in 3.3.2, scale
	tmpmouseX = Math.round( ( e.clientX - canvas_x_offset ) * psy_screen_width / canvas_w ) ;
	tmpmouseY = Math.round( ( e.clientY - canvas_y_offset ) * psy_screen_height / canvas_h ) ;

	var correctbitmapclicked = false ;
	if ( tmpmouseX >= psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.x &&
             tmpmouseX <= psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.x+psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.width &&
	     tmpmouseY >= psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.y &&
             tmpmouseY <= psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.y+psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.height ){
	    correctbitmapclicked = true
	    keystatus.bitmap = psy_readkey.bitmap ;
	}else{
	    keystatus.bitmap = psy_bitmap_under_mouse( 0 , -1 , -1 , tmpmouseX - psy_screen_x_offset , tmpmouseY - psy_screen_y_offset );
	}

	//addlog( "mouseX = "+tmpmouseX+" should be between [" + psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.x + "," + (psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.x+psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.width) + "]" )
	//addlog( "mouseY = "+tmpmouseY+" should be between [" + psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.y + "," + (psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.y+psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.height) + "]" )		    

	
	if ( psy_readkey.expectedkey == e.button && correctbitmapclicked == true )
	    keystatus.status = 1
	else
	    keystatus.status = 2

	keystatus.mouse_x = tmpmouseX - psy_screen_x_offset
	keystatus.mouse_y = tmpmouseY - psy_screen_y_offset

	psy_readkey.expect_mouse = false
	psy_readkey.stop()
    }

    // case 2: there is a specific range of bitmaps to look for bitmap_range.
    // new since 2.3.6, the resulting bitmap will be stored as well in keystatus.bitmap
    if ( psy_readkey.expect_mouse == true && psy_readkey.bitmap_range[0] > -1 && !psy_readkey.array_search){
	keystatus.time = new Date().getTime() - psy_readkey.starttime ;

	canvas_x_offset = psy_canvas.getBoundingClientRect().left ;
	canvas_y_offset = psy_canvas.getBoundingClientRect().top	    
	canvas_w = psy_canvas.getBoundingClientRect().width;
	canvas_h = psy_canvas.getBoundingClientRect().height;

	// new in 3.3.2, scale
	tmpmouseX = Math.round( ( e.clientX - canvas_x_offset ) * psy_screen_width / canvas_w ) ;
	tmpmouseY = Math.round( ( e.clientY - canvas_y_offset ) * psy_screen_height / canvas_h ) ;

	// step 1: figure out which bitmap the mouse is on
	//--->following line does not yet work, it always returns 0 | DEBUG

	// NOTE: change to psytoolkit coordinates, because that is what psy_bitmap_under_mouse uses
	var tmpbitmap = psy_bitmap_under_mouse( 0 , psy_readkey.bitmap_range[0] , psy_readkey.bitmap_range[1] ,
						tmpmouseX - psy_screen_x_offset , tmpmouseY - psy_screen_y_offset )

	// TODO TO CHECK
	// WE MIGHT NEED TO COPY tmpbitmap to keystatus.bitmap here as well (Oct 2017)

	//addlog("bitmap undermouse (range):"+tmpbitmap+" at X "+tmpmouseX+" at Y "+tmpmouseY+" in range: "+
	//       psy_readkey.bitmap_range[0] + " "+psy_readkey.bitmap_range[1] )

	// step 2: Only if the bitmap is in the range, respond to it
	if ( tmpbitmap >= psy_readkey.bitmap_range[0] && tmpbitmap <= psy_readkey.bitmap_range[1] ){
	
	    var correctbitmapclicked = false ;
	    keystatus.bitmap = tmpbitmap ;

	    if ( tmpmouseX >= psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.x &&
		 tmpmouseX <= psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.x+psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.width &&
		 tmpmouseY >= psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.y &&
		 tmpmouseY <= psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.y+psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.height ){
		correctbitmapclicked = true ;
	    }

	    if ( psy_readkey.expectedkey == e.button && correctbitmapclicked == true )
		keystatus.status = 1 ;
	    else
		keystatus.status = 2 ;
	    
	    keystatus.mouse_x = tmpmouseX - psy_screen_x_offset ;
	    keystatus.mouse_y = tmpmouseY - psy_screen_y_offset ;
	    
	    psy_readkey.expect_mouse = false ;

	    psy_readkey.bitmap_range = [-1,-1] ; // return to standard value
	    
	    psy_readkey.stop() ;
	}
    }

    // case 3: there is a an array range of bitmaps to look for bitmap_range (new in 3.2.0)
    // TODO: make sure array_search will be set to false afterwards
    if ( psy_readkey.expect_mouse == true && psy_readkey.bitmap_range[0] > -1 && psy_readkey.array_search){
	keystatus.time = new Date().getTime() - psy_readkey.starttime ;

	canvas_x_offset = psy_canvas.getBoundingClientRect().left ;
	canvas_y_offset = psy_canvas.getBoundingClientRect().top	    
	canvas_w = psy_canvas.getBoundingClientRect().width;
	canvas_h = psy_canvas.getBoundingClientRect().height;

	// new in 3.3.2, scale
	tmpmouseX = Math.round( ( e.clientX - canvas_x_offset ) * psy_screen_width / canvas_w ) ;
	tmpmouseY = Math.round( ( e.clientY - canvas_y_offset ) * psy_screen_height / canvas_h ) ;

	var tmpbitmap = psy_bitmap_under_mouse_in_range( psy_readkey.bitmap_range ,
						         tmpmouseX - psy_screen_x_offset , tmpmouseY - psy_screen_y_offset )

	// step 2: Only if the stimulus is in the range (that is, it is greater than 0)
	if ( tmpbitmap > 0 ){
	
	    var correctbitmapclicked = false ;
	    keystatus.bitmap = tmpbitmap ;

	    if ( tmpmouseX >= psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.x &&
		 tmpmouseX <= psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.x+psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.width &&
		 tmpmouseY >= psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.y &&
		 tmpmouseY <= psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.y+psy_stimuli1[ psy_readkey.bitmap - 1 ].rect.height ){
		correctbitmapclicked = true ;
	    }

	    if ( psy_readkey.expectedkey == e.button && correctbitmapclicked == true )
		keystatus.status = 1 ;
	    else
		keystatus.status = 2 ;
	    
	    keystatus.mouse_x = tmpmouseX - psy_screen_x_offset ;
	    keystatus.mouse_y = tmpmouseY - psy_screen_y_offset ;
	    
	    psy_readkey.expect_mouse = false ;

	    psy_readkey.bitmap_range = [-1,-1] ; // return to standard value
	    psy_readkey.array_search = false ;  // return to standard value
	    
	    psy_readkey.stop() ;
	}
    }
}

//////////////////////////////////////////////////////////////////////
// further mouse functions
// these functions set some variables and timers and then return

// note, the mouse even listener seems to me resource intense, because
// it calls the function every time when the mouse is
// moved. Therefore, I decided to use this window listener only when
// needed, and it is set up and deleted only when needed with
// addEventListener and removeEventlistener

function psy_mouse_in_bitmap_rectangle( bitmap , maxwait )
{
    psy_readkey.bitmap = bitmap ;
    window.addEventListener("mousemove",getmouse_in_area,false) ; // use this listener only when needed
    psy_readkey.mouseovereventlistener = 1 ;
    psy_expect_mouse()    
    psy_readkey.start( current_task , maxwait );
}

function psy_mouse_in_bitmap_rectangle_check_all( bitmap , maxwait , range1 , range2 )
{
    psy_readkey.bitmap = bitmap ;
    psy_readkey.bitmap_range[0] = range1 ;
    psy_readkey.bitmap_range[1] = range2 ;
    window.addEventListener("mousemove",getmouse_in_area_check_all,false) ; // use this listener only when needed
    psy_readkey.mouseovereventlistener = 2 ;
    psy_expect_mouse();    
    psy_readkey.start( current_task , maxwait );
}

function psy_mouse_click_bitmap_rectangle( mousebutton , bitmap , maxwait )
{
    psy_readkey.bitmap = bitmap ;
    if ( mousebutton=="l" ) { psy_readkey.expectedkey = 0 ; }else{ psy_readkey.expectedkey = 1 ; }
    window.addEventListener("mousemove",getmouse_track,false); // use this listener only when needed
    window.addEventListener("mousedown",getmouseclick_in_area,false); // use this listener only when needed
    psy_readkey.mousedowneventlistener = true ;
    psy_expect_mouse();
    psy_readkey.start( current_task , maxwait );
}

function psy_mouse_click_bitmap_rectangle_range( mousebutton , bitmap , maxwait , first , last )
{
    psy_readkey.bitmap = bitmap ;
    if ( mousebutton=="l" ) { psy_readkey.expectedkey = 0 ; }else{ psy_readkey.expectedkey = 1 ; }
    window.addEventListener("mousemove",getmouse_track,false); // use this listener only when needed
    window.addEventListener("mousedown",getmouseclick_in_area,false) ; // use this listener only when needed
    psy_readkey.mousedowneventlistener = true ;
    psy_readkey.bitmap_range = [ first , last ] ;
    psy_expect_mouse() ;
    psy_readkey.start( current_task , maxwait );
}

// new in 3.2.0
function psy_mouse_click_bitmap_rectangle_array( mousebutton , bitmap , maxwait , find_in_array )
{
    psy_readkey.bitmap = bitmap ;
    if ( mousebutton=="l" ) { psy_readkey.expectedkey = 0 ; }else{ psy_readkey.expectedkey = 1 ; }
    window.addEventListener("mousedown",getmouseclick_in_area,false) ; // use this listener only when needed
    psy_readkey.mousedowneventlistener = true ;
    psy_readkey.bitmap_range = find_in_array ;
    psy_readkey.array_search = true ;
    psy_expect_mouse() ;
    psy_readkey.start( current_task , maxwait );
}


// this function is necessary for the _range mouse functions (it is called within getmouseclick_in_area
function psy_bitmap_under_mouse( searchdirection , first, last, x , y ) 
{
    // addlog("CALL: psybitmap_under_mouse( "+searchdirection+" , "+first+" , "+last+" , "+x+" , "+y+" )")
    
    /* x and y mouse given must be position in psytoolkit coordinate system (hence, needs to be corrected) */
    
    var i = 0 ; var j = 0 ; var tmp = 0 ;
    var found_bitmap = -1 ;
    var allchecked = 1 ; /* in c conditions: anything else than 0 is true */
    
    i = 0 ;
    // we assume we use double buffering, in C/Java this an option, in Javascript it is standard
    j = psy_stimuli1_n ; /* in double buffering, a different variable counts static stimuli */
    
    if ( first > -1 ) i = first - 1 ; /* bitmap numbers start with 1 */
    if ( last  > -1 ) j = last - 1 ;
	
    /* we need to iterate through all stimuli (bitmaps, but also
       rectangles), and we must make sure that the initial values are
       set correctly, the following two if statements just check if
       the searchdirection is correct
    */
    //addlog("search direction = "+searchdirection+" i = "+i+"  j = "+j)
    if ( searchdirection == 0 && i > j ) /* from low to high, i must be < than j */
    {
	tmp = j ; /* swap i and j */
	j = i   ;
	i = tmp ;
    }
    if ( searchdirection == 1 && i < j )  /* from high to low, i must be > than j */
    {
	tmp = j ; /* swap i and j */
	j = i   ;
	i = tmp ;
    }
    
    /* now iterate from i to j or from j to i, depending on search direction */
    
    while ( allchecked == 1 && found_bitmap == -1 )
    {
	//addlog("psy_screen_x_offset = "+psy_screen_x_offset)
	//addlog("In search for bitmap in psy_bitmap_under_mouse (x,y)" + x+" "+y)
	if ( x + psy_screen_x_offset >= psy_stimuli1[ i ].rect.x                              &&
	     x + psy_screen_x_offset <= psy_stimuli1[ i ].rect.x+psy_stimuli1[ i ].rect.width &&
	     y + psy_screen_y_offset >= psy_stimuli1[ i ].rect.y                              &&
	     y + psy_screen_y_offset <= psy_stimuli1[ i ].rect.y+psy_stimuli1[ i ].rect.height   )
	{
	    found_bitmap = i ;
	}else{
	    // THIS WHOLE ELSE IS DEBUG 1.9.7
	    //addlog("comp1 >= comp2 :: "+(x+psy_screen_x_offset)+" >= "+ psy_stimuli1[ i ].rect.x )
	}

	// DEBUG --> CHECK 1.9.7 THESE IFS NEED TO HAVE FOUNDBITMAP != -1
	if ( searchdirection == 0 && found_bitmap == -1 ) /* counter goes up, from i to j, from first to last */
	{
	    if ( i >= j ) allchecked = 0 ;
	    i++ ;
	}
	if ( searchdirection == 1 && found_bitmap == -1 ) /* counter goes up, from i to j, from first to last */
	{
	    if ( i <= j ) allchecked = 0 ;
	    i-- ;
	}
    }
    //addlog("FOUND BITMAP: "+(found_bitmap+1))
    return( found_bitmap + 1 );
}

function psy_bitmap_under_mouse_in_range( check_in_range , x , y ) // new in 3.2.0 for get
{
    /* x and y mouse given must be position in psytoolkit coordinate system (hence, needs to be corrected) */
    
    var found_bitmap = -1 ;
    var allchecked = 1 ; /* in c conditions: anything else than 0 is true */
    
    var i = 0 , tmp = 0 ;
    
    /* now iterate from i to j or from j to i, depending on search direction */
    
    while ( i < check_in_range.length && found_bitmap == -1 )
    {
	tmp = check_in_range[ i ] - 1 ;
	if ( x + psy_screen_x_offset >= psy_stimuli1[ tmp ].rect.x                                &&
	     x + psy_screen_x_offset <= psy_stimuli1[ tmp ].rect.x+psy_stimuli1[ tmp ].rect.width &&
	     y + psy_screen_y_offset >= psy_stimuli1[ tmp ].rect.y                                &&
	     y + psy_screen_y_offset <= psy_stimuli1[ tmp ].rect.y+psy_stimuli1[ tmp ].rect.height   )
	{
	    found_bitmap = tmp ;
	}

	if( i < check_in_range.length && found_bitmap == -1 ) i++ ;
    }
    //addlog("FOUND BITMAP: "+(found_bitmap+1))
    return( found_bitmap + 1 );
}

//////////////////////////////////////////////////////////////////////
// functions that are often used from within block calls

function psy_wait( stimulus , key ) // can only be called from within block. stimulus can be string or number
{
    if ( Number.isFinite( stimulus ) ){
	if ( stimulus != 0 ){
	    psy_clear_stimulus_counters_db();
	    psy_add_centered_bitmap_db( stimulus , PSY_CENTRAL,PSY_CENTRAL,0 );
            psy_draw_all_db();
	}
    }else{ // new in 3.3.0
	psy_clear_stimulus_counters_db();
	psy_add_text_rgb_db( 1 , PSY_CENTRAL, PSY_CENTRAL , PSY_CENTRAL, PSY_CENTRAL , 255 , 255, 255 , stimulus , 0 );
        psy_draw_all_db();
    }
    
    if ( key >= 0 ){
	psy_readkey.expectedkey = key ;
	psy_readkey.keys = [ key ] ; // new in 2.0.5
	psy_expect_keyboard() ;
	psy_readkey.start( current_block , 99999999 ); // endless wait
    }else{ // mouse call, code copied from psy_mouse_click_bitmap_rectangle (except "current_block")
	psy_mouse_visibility( 1 ); // this will be automatically undone if needed through psycc calls
	psy_readkey.bitmap = 1 ;
	psy_readkey.expectedkey = 0 ;
	window.addEventListener("mousedown",getmouseclick_in_area,false) ; // use this listener only when needed
	psy_readkey.mousedowneventlistener = true ;
	psy_expect_mouse() ;
	psy_mouse_click_bitmap_rectangle( "l" , 1 , 9999999 );
	psy_readkey.start( current_block , 99999999 );
    }
}


var psy_pager = {
    original_block: "",
    current_bitmap_in_pager : 0 ,
    bitmaps: [],
    n: 0,

    start: function( bitmaps ){
	// first save which block you come from and later need to return to
	psy_pager.original_block = current_block ;
	psy_pager.n = bitmaps.length ;
	psy_pager.bitmaps = bitmaps ;
	// and now replace current block with this page function
	current_block = "psy_pager" ;
	// set which of the bitmaps is currently being shown
	psy_pager.current_bitmap_in_pager = 0 ;
	keystatus.key = -1 // make sure that the old keystatus is cleared.
	psy_pager.run()
    },

    // 32 = space, up = 38, down=40

    run: function(){
	//addlog( psy_pager.current_bitmap_in_pager )
	if ( (keystatus.key == 0 || keystatus.key == 1 ) && psy_pager.current_bitmap_in_pager < (psy_pager.n-1)  )
	    psy_pager.current_bitmap_in_pager ++ ;

	if ( keystatus.key == 2 && psy_pager.current_bitmap_in_pager > 0 )
	    psy_pager.current_bitmap_in_pager -- ;

	if ( keystatus.key == 3 ){ // keycode (81) in array for button press of letter Q
	    current_block = psy_pager.original_block ; 
	    psy_clear_screen_db() ;
	    setTimeout(current_block+".run()",10) // wait 10 ms to refresh screen CHECK
	}else{
	    // only if q not pressed
	    // addlog( psy_pager.current_bitmap_in_pager )
	    // psy_wait( psy_pager.bitmaps[ psy_pager.current_bitmap_in_pager ] , 32 ) // old (2.0.5)

	    psy_clear_stimulus_counters_db();
	    psy_add_centered_bitmap_db( psy_pager.bitmaps[ psy_pager.current_bitmap_in_pager ] , PSY_CENTRAL,PSY_CENTRAL,0 );
            psy_draw_all_db();

	    psy_readkey.expectedkey = 32 ;
	    psy_readkey.keys = [ 32,40,38,81 ] ; // space,up,down,q
	    psy_expect_keyboard() ;
	    psy_readkey.start( current_block , 99999999 ); // endless wait
	}
    }
}

function psy_store_mouse(){
    psy_mouse_store = psy_mouse_cursor ; // save mouse state (visibility)
}
function psy_restore_mouse(){
    psy_mouse_visibility( psy_mouse_store ); // restore mouse cursor state (visibility)
}

var psy_mouse_pager = {
    original_block: "",
    current_bitmap_in_pager : 0 ,
    read_all : false ,
    bitmaps: [],
    n: 0,

    start: function( bitmaps ){
	// first save which block you come from and later need to return to
	psy_mouse_pager.original_block = current_block ;
	psy_mouse_pager.n = bitmaps.length ;
	psy_mouse_pager.bitmaps = bitmaps ;
	// and now replace current block with this page function
	current_block = "psy_mouse_pager" ;
	// set which of the bitmaps is currently being shown
	psy_mouse_pager.current_bitmap_in_pager = 0 ;
	psy_mouse_pager.read_all = false ;	
	keystatus.key = -1 // make sure that the old keystatus is cleared.
	psy_mouse_pager.run()
	psy_store_mouse(); // saves state until restore
	psy_mouse_visibility( 1 );
    },

    run: function(){
	// addlog( psy_mouse_pager.current_bitmap_in_pager )
        // there are always 4 bitmaps on screen
	// stimulus 1: the instruction
	// stimulus 2: previous
	// stimulus 3: next
	// stimulus 4: quit (only shown once all read)

	// inititalise where we are at (we need to know if we are at start of at end
	at_start = false
	at_end   = false
	// find where we are
	if ( psy_mouse_pager.current_bitmap_in_pager == 0 ){ at_start = true }else{ at_start = false }
	if ( psy_mouse_pager.current_bitmap_in_pager == (psy_mouse_pager.n-1) ){ at_end = true }else{ at_end = false }

	quitbutton = 4 // by default is 4, but can be 3 if there are not a previous or next bitmap shown
	if ( at_start || at_end ){ quitbutton = 3 }

	////////////////////////////////////////////////////////
	// go previous/next based on key presses

	if ( keystatus.bitmap != 0 ){

	    // next_page_stimulus can be 2 if we are at the start page (with no "previous" stimulus)
	    next_page_stimulus = 3
	    if ( psy_mouse_pager.current_bitmap_in_pager == 0 ){
		next_page_stimulus = 2
	    }

	    // check if next page was clicked (which cannot be the case if in last page)
	    if ( keystatus.bitmap == next_page_stimulus && at_end == false ){
		psy_mouse_pager.current_bitmap_in_pager ++ ;
		if ( psy_mouse_pager.current_bitmap_in_pager == psy_mouse_pager.n-1 )
		    psy_mouse_pager.read_all = true ;
	    }

	    // check if previous page was clicked (which cannot be the case if in last page)
	    if ( keystatus.bitmap == 2 && at_start == false ){
		psy_mouse_pager.current_bitmap_in_pager -- ;
	    }
	}

	////////////////////////////////////////////////////////
	// Now first check if quitbutton was pressed

	if ( keystatus.bitmap == quitbutton ){ // keycode (81) in array for button press of letter Q
	    current_block = psy_mouse_pager.original_block ; 
	    psy_clear_screen_db() ;
	    psy_restore_mouse(); // visible or not
	    setTimeout(current_block+".run()",10) // wait 10 ms to refresh screen CHECK
	}else{
	    // NOW DRAW THE LABELS PREVIOUS/NEXT ETC
	    // only if quit is not clicked
	    // addlog( psy_mouse_pager.current_bitmap_in_pager )
	    // psy_wait( psy_mouse_pager.bitmaps[ psy_mouse_pager.current_bitmap_in_pager ] , 32 ) // old (2.0.5)
	    psy_clear_stimulus_counters_db();
	    psy_add_centered_bitmap_db( psy_mouse_pager.bitmaps[ psy_mouse_pager.current_bitmap_in_pager ] , PSY_CENTRAL,PSY_CENTRAL,0 ); // stimulus 1

	    if ( psy_mouse_pager.current_bitmap_in_pager > 0 ){ // only show "previous" if not at start
		psy_add_centered_bitmap_db( pager_options.back , pager_options.backX , pager_options.backY , 0 ); // stimulus 2
	    }
	    if ( psy_mouse_pager.current_bitmap_in_pager < (psy_mouse_pager.n-1)){ // only show "next" if not at end
		psy_add_centered_bitmap_db( pager_options.next , pager_options.nextX , pager_options.nextY , 0 ); // stimulus 3
	    }
	    if ( psy_mouse_pager.read_all == true ) // only show once all have been shown
		psy_add_centered_bitmap_db( pager_options.quit , pager_options.quitX , pager_options.quitY , 0 ); // stimulus 3 or 4 (depending)

            psy_draw_all_db();
	    psy_expect_mouse() ;

	    psy_mouse_click_bitmap_rectangle_range( "l" , 2 , 9999999 , 2 , psy_stimuli1_end ); // TODO: There might even just be 1 stimulus (e.g., just "next")

	    psy_readkey.start( current_block , 99999999 ); // need to set it to "current_block" and endless wait
	}
    }
}

//////////////////////////////////////////////////////////////////////
// adding text to offline rendered images (here just another
// Javascript canvas. Code based on the Java version
// explained here: http://kaioa.com/node/103
//////////////////////////////////////////////////////////////////////

// since 3.2.0, fontno is from 1 onwards, but the arrays with fonts of
// course start at 0, so we subtract one.

function psy_add_text_rgb_db( fontno , x , y , centerx , centery , r , g , b , text , align)
{
    /* this function renders text to a structure, which will then be rendered by psy_draw_all_db */
    var xpos=0, ypos=0,width=0,height=0; /* textpos on screen */

    // add new object
    psy_stimuli1[ psy_stimuli1_end ] = new psy_stimulus1 ;
    psy_stimuli1[ psy_stimuli1_end ].rect = new Rectangle ;

    psy_stimuli1[ psy_stimuli1_end ].x = x ;
    psy_stimuli1[ psy_stimuli1_end ].y = y ;        

    psy_stimuli1[ psy_stimuli1_end ].type = 2 ; // 2 is "text"
    psy_stimuli1[ psy_stimuli1_end ].on = 1 ;
    
    ctx.font = psy_fonts[ fontno - 1 ] ; // even though you do not draw on ctx, you need to set the font for measureText
    tmpsize = ctx.measureText(text); // size of string. Javascript does not give height, only width

    height  = psy_fonts_size[ fontno - 1 ] // just based on the pixel size, but this will ignore the bottom part of letters (see below)
    width   = tmpsize.width

    tmpgraphicsCanvas         = document.createElement("canvas")
    tmpgraphicsCanvas.width   = width

    // CHECK. This makes sure the bottom part of letters are displayed!
    // whether 1.3 is good or not is unclear, but it works nicely with Arial

    // For testing size, this is a good place to go:
    // https://www.w3schools.com/tags/tryit.asp?filename=tryhtml5_canvas_filltext

    tmpgraphicsCanvas.height  = Math.round( height * 2 )

    tmpgraphics = tmpgraphicsCanvas.getContext("2d")
    tmpgraphics.fillStyle = "rgba(0,0,0,0)"
    tmpgraphics.fillRect(0,0,width,height)

    tmpgraphics.fillStyle = hexrgb( r , g , b ) ; // text color
    tmpgraphics.font = psy_fonts[ fontno - 1 ]
    tmpgraphics.fillText( text , 0 , height + height/2)

    psy_stimuli1[ psy_stimuli1_end ].text = tmpgraphicsCanvas
    
    //////////////////////////////////////////////////////////////////////
    
    xpos = x ;
    ypos = y ;

    if ( align == 0 ){
	if ( x == PSY_CENTRAL && centerx == PSY_CENTRAL ) xpos = psy_screen_center_x - width / 2 ;
	if ( x != PSY_CENTRAL && centerx == PSY_CENTRAL ) xpos = x + psy_screen_x_offset - width / 2 ;
	if ( y == PSY_CENTRAL && centery == PSY_CENTRAL ) ypos = psy_screen_center_y - height ;
	if ( y != PSY_CENTRAL && centery == PSY_CENTRAL ) ypos = y + psy_screen_y_offset - height ;
    }
    if ( align == 1 ){
	if ( x == PSY_CENTRAL && centerx == PSY_CENTRAL ) xpos = psy_screen_center_x ;
	if ( x != PSY_CENTRAL && centerx == PSY_CENTRAL ) xpos = x + psy_screen_x_offset ;
	if ( y == PSY_CENTRAL && centery == PSY_CENTRAL ) ypos = psy_screen_center_y - height ;
	if ( y != PSY_CENTRAL && centery == PSY_CENTRAL ) ypos = y + psy_screen_y_offset- height ;
    }
    if ( align == 2 ){
	if ( x == PSY_CENTRAL && centerx == PSY_CENTRAL ) xpos = psy_screen_center_x - width ;
	if ( x != PSY_CENTRAL && centerx == PSY_CENTRAL ) xpos = x + psy_screen_x_offset - width ;
	if ( y == PSY_CENTRAL && centery == PSY_CENTRAL ) ypos = psy_screen_center_y - height ;
	if ( y != PSY_CENTRAL && centery == PSY_CENTRAL ) ypos = y + psy_screen_y_offset- height ;
    }
    
    if ( xpos < 0 ) xpos = 0 ;
    if ( ypos < 0 ) ypos = 0 ;
    if ( xpos > psy_screen_width ) xpos = psy_screen_width - width ;
    if ( ypos > psy_screen_height ) ypos = psy_screen_height - height ;

    /* -- coordinate setting dones -- */
    
    psy_stimuli1[ psy_stimuli1_end ].rect.x      = xpos ;
    psy_stimuli1[ psy_stimuli1_end ].rect.y      = ypos ;
    psy_stimuli1[ psy_stimuli1_end ].rect.width  = width ;
    psy_stimuli1[ psy_stimuli1_end ].rect.height = height * 2 ; // this is only used for mouse clicks
    
    psy_stimuli1_n ++ ;
    psy_stimuli1_end ++ ;
    return( psy_stimuli1_end );
}

//////////////////////////////////////////////////////////////////////
// new in 3.6.0, this way you can change the text. You still need all
// the other parameters, because they are not all stored in the
// stimlus

function psy_change_text_rgb_db( stimulus_number , fontno , x , y , centerx , centery , r , g , b , text , align )
{
    /* this function renders text to a structure, which will then be rendered by psy_draw_all_db */
    var xpos=0, ypos=0,width=0,height=0; /* textpos on screen */

    // add new object
    // psy_stimuli1[ psy_stimuli1_end ] = new psy_stimulus1 ;
    // psy_stimuli1[ psy_stimuli1_end ].rect = new Rectangle ;

    psy_stimuli1[ stimulus_number - 1 ].x = x ; // is this needed?
    psy_stimuli1[ stimulus_number - 1 ].y = y ; // is this needed?

    // psy_stimuli1[ psy_stimuli1_end ].type = 2 ; // 2 is "text"
    // psy_stimuli1[ psy_stimuli1_end ].on = 1 ;
    
    ctx.font = psy_fonts[ fontno - 1 ] ; // even though you do not draw on ctx, you need to set the font for measureText
    tmpsize = ctx.measureText(text); // size of string. Javascript does not give height, only width

    height  = psy_fonts_size[ fontno - 1 ] // just based on the pixel size, but this will ignore the bottom part of letters (see below)
    width   = tmpsize.width

    tmpgraphicsCanvas         = document.createElement("canvas")
    tmpgraphicsCanvas.width   = width

    // CHECK. This makes sure the bottom part of letters are displayed!
    // whether 1.3 is good or not is unclear, but it works nicely with Arial

    // For testing size, this is a good place to go:
    // https://www.w3schools.com/tags/tryit.asp?filename=tryhtml5_canvas_filltext

    tmpgraphicsCanvas.height  = Math.round( height * 2 )

    tmpgraphics = tmpgraphicsCanvas.getContext("2d")
    tmpgraphics.fillStyle = "rgba(0,0,0,0)"
    tmpgraphics.fillRect(0,0,width,height)

    tmpgraphics.fillStyle = hexrgb( r , g , b ) ; // text color
    tmpgraphics.font = psy_fonts[ fontno - 1 ]
    tmpgraphics.fillText( text , 0 , height + height/2)

    psy_stimuli1[ stimulus_number - 1 ].text = tmpgraphicsCanvas
    
    //////////////////////////////////////////////////////////////////////
    
    xpos = x ;
    ypos = y ;

    if ( align == 0 ){
	if ( x == PSY_CENTRAL && centerx == PSY_CENTRAL ) xpos = psy_screen_center_x - width / 2 ;
	if ( x != PSY_CENTRAL && centerx == PSY_CENTRAL ) xpos = x + psy_screen_x_offset - width / 2 ;
	if ( y == PSY_CENTRAL && centery == PSY_CENTRAL ) ypos = psy_screen_center_y - height ;
	if ( y != PSY_CENTRAL && centery == PSY_CENTRAL ) ypos = y + psy_screen_y_offset - height ;
    }
    if ( align == 1 ){
	if ( x == PSY_CENTRAL && centerx == PSY_CENTRAL ) xpos = psy_screen_center_x ;
	if ( x != PSY_CENTRAL && centerx == PSY_CENTRAL ) xpos = x + psy_screen_x_offset ;
	if ( y == PSY_CENTRAL && centery == PSY_CENTRAL ) ypos = psy_screen_center_y - height ;
	if ( y != PSY_CENTRAL && centery == PSY_CENTRAL ) ypos = y + psy_screen_y_offset- height ;
    }
    if ( align == 2 ){
	if ( x == PSY_CENTRAL && centerx == PSY_CENTRAL ) xpos = psy_screen_center_x - width ;
	if ( x != PSY_CENTRAL && centerx == PSY_CENTRAL ) xpos = x + psy_screen_x_offset - width ;
	if ( y == PSY_CENTRAL && centery == PSY_CENTRAL ) ypos = psy_screen_center_y - height ;
	if ( y != PSY_CENTRAL && centery == PSY_CENTRAL ) ypos = y + psy_screen_y_offset- height ;
    }
    
    if ( xpos < 0 ) xpos = 0 ;
    if ( ypos < 0 ) ypos = 0 ;
    if ( xpos > psy_screen_width ) xpos = psy_screen_width - width ;
    if ( ypos > psy_screen_height ) ypos = psy_screen_height - height ;

    /* -- coordinate setting dones -- */
    
    psy_stimuli1[ stimulus_number - 1 ].rect.x      = xpos ;
    psy_stimuli1[ stimulus_number - 1 ].rect.y      = ypos ;
    psy_stimuli1[ stimulus_number - 1 ].rect.width  = width ;
    psy_stimuli1[ stimulus_number - 1 ].rect.height = height * 2 ; // this is only used for mouse clicks
    
    // return( psy_stimuli1_end ); // we do not need to return anything
}


//////////////////////////////////////////////////////////////////////

function psy_clear_screen_db()
{
    psy_clear_stimulus_counters_db();
    psy_draw_all_db();
}

//////////////////////////////////////////////////////////////////////

function psy_clear_stimuli1( number )
{
    var tmp ;
    
    if ( number < 0 )
	tmp = psy_stimuli1_end + number ; /* plus sign, because number is negative */
    else
	tmp = number - 1 ;

    // only do this if the stimulus can exist
    if ( tmp >= 0 && tmp < psy_stimuli1_end ){
	// only do this if the stimulus has not already been cleared
	if ( psy_stimuli1[ tmp ].on != 0 ){
	    psy_stimuli1[ tmp ].on = 0 ;
	    
	    // special case video (5), they need be stopped. Bitmap field contains the video number
	    if ( psy_stimuli1[ tmp ].type == 5 )
		psy_videos[ psy_stimuli1[ tmp ].bitmap - 1 ].clear();
	    psy_stimuli1_n -- ;
	}
    }
}

function psy_unhide_stimuli1( number )
{
    var tmp ;
    
    if ( number < 0 )
	tmp = psy_stimuli1_end + number ; /* plus sign, because number is negative */
    else
	tmp = number - 1 ;

    // only do this is the stimulus has not already been cleared
    if ( psy_stimuli1[ tmp ].on != 1 ){
	psy_stimuli1[ tmp ].on = 1 ;
	psy_stimuli1_n ++ ;
    }
}

function psy_clear_range_db( low , high )
{
    var x = 0 ;
    var i = low ;
    var j = high ;
    if ( low > high ){ j=low ; i=high ; } // in case high < low
    for( x=i ; x <= j ; x++ ) psy_clear_stimuli1( x ) ;
}

function psy_clear_array_db( a )
{
    for( var i=0;i<a.length;i++ ) psy_clear_stimuli1( a[i] ) ;
}

function psy_unhide_range_db( low , high )
{
    var x = 0 ;
    var i = low ;
    var j = high ;
    if ( low > high ){ j=low ; i=high ; } // in case high < low
    for( x=i ; x <= j ; x++ ) psy_unhide_stimuli1( x ) ;
}


function psy_clear_stimulus_counters_db()
{
    var i = 0 ;
    while ( i < psy_stimuli1_n )
    {
	psy_stimuli1[i].on = 0 ;
	i++;
    }
    
    psy_stimuli1_n = psy_stimuli1_end = 0 ;
}

function psy_random( low, high )
{
    return ( Math.floor( Math.random()*(high-low+1)+low ));
}

function psy_random_weighted( chances , n )
{
    /* chances is a vector of numbers, whereby each chance is a value
       between 0 and 1. If the chance is 0, it will not be selected */
    
    var choosen = 0 ;
    var chance = 0 ;
    var max_chance = 0 ;
    var i ;

    /* the probability of choosing is weighted */
    
    for( i = 0 ; i < n ; i ++ )
    {
	if ( chances[i] > 0 ) /* only consider probs over 0 */
	{
	    chance = psy_random( chances[i]*10000 , 10000 );
	    
	    if ( chance > max_chance )
	    {
		max_chance = chance ;
		choosen = i ;
	    }
	}
    }
    return( choosen );
}

function psy_random_by( low, high , by )
{
    return( Math.floor( Math.random()*(high+by-low)/by)*by+low)
}

function psy_random_from_array( tmparray )
{
    return( tmparray[ Math.round(Math.random()*(tmparray.length-1)) ] )
}

function psy_draw_all_db()
{
    var i = 0 , j = 0;  /* tmp counters */
    var activefound = 0 ; /* used to count how many of the active static stimuli have been drawn so far */

    ctx.fillStyle = hexrgb(psy_bgcol_r,psy_bgcol_g,psy_bgcol_b);
    ctx.fillRect(0,0,psy_screen_width,psy_screen_height);

    //addlog("xxx--"+activefound+" "+psy_stimuli1_n)
    
    while ( activefound < psy_stimuli1_n ) /* stimuli1 are the static stimuli; bitmaps,rectangles, and texts */
    {
	if ( psy_stimuli1[i].on == 1 )
	{
	    activefound ++ ; /* keep track how many stimuli you have drawn so far */

	    //addlog( "type: "+psy_stimuli1[i].type )
	    //addlog( "rect x: "+psy_stimuli1[i].rect.x)
	    switch ( psy_stimuli1[i].type )
	    {
	    case 0: /* draw a rectangle, as setup with psy_add_centered_rectangle */
		ctx.fillStyle = hexrgb( psy_stimuli1[i].r,psy_stimuli1[i].g,psy_stimuli1[i].b );

		if ( psy_stimuli1[i].R == 0 )
		    ctx.fillRect( psy_stimuli1[i].rect.x ,psy_stimuli1[i].rect.y ,psy_stimuli1[i].rect.width ,psy_stimuli1[i].rect.height );
		else
		{
		    ctx.save();
                    ctx.translate( psy_stimuli1[i].rect.x + psy_stimuli1[i].rect.width / 2 ,
                                   psy_stimuli1[i].rect.y + psy_stimuli1[i].rect.height / 2 );
                    ctx.rotate(psy_stimuli1[i].R * Math.PI / 1800);
		    ctx.fillRect( -1 * psy_stimuli1[i].rect.width / 2 , -1 * psy_stimuli1[i].rect.height / 2 , 
				  psy_stimuli1[i].rect.width ,psy_stimuli1[i].rect.height );
		    ctx.restore();
		}
		break;
		
	    case 1: /* draw a bitmap, as setup with psy_add_centered_bitmap */
		// addlog("draw image "+psy_stimuli1[i].bitmap)
		if ( psy_stimuli1[i].R == 0 )
		    ctx.drawImage( psy_bitmaps[ psy_stimuli1[i].bitmap - 1 ] , psy_stimuli1[i].rect.x , psy_stimuli1[i].rect.y );
		else
		{
		    ctx.save();
                    ctx.translate( psy_stimuli1[i].rect.x + psy_stimuli1[i].rect.width / 2 ,
                                   psy_stimuli1[i].rect.y + psy_stimuli1[i].rect.height / 2 );
                    ctx.rotate(psy_stimuli1[i].R * Math.PI / 1800);
                    ctx.drawImage(psy_bitmaps[psy_stimuli1[i].bitmap - 1], 
				  -1 * psy_stimuli1[i].rect.width / 2 , 
				  -1 * psy_stimuli1[i].rect.height / 2 ) ;
		    ctx.restore();
		}
		break;
		
            case 2: /* draw a text, as setup with psy_add_text_rgb ; the image is drawn */
		ctx.drawImage( psy_stimuli1[ i ].text , psy_stimuli1[i].rect.x , psy_stimuli1[i].rect.y );
		break;

	    case 3: /* draw a circle, added to 2.2.1 */
		// http://www.html5canvastutorials.com/tutorials/html5-canvas-circles/
		ctx.fillStyle = hexrgb( psy_stimuli1[i].r,psy_stimuli1[i].g,psy_stimuli1[i].b );
		ctx.beginPath();
		// note that x/y should be center of the screen rectangle, which is different from rectanlge presentation
		ctx.arc( psy_stimuli1[i].rect.x + psy_stimuli1[i].rect.width / 2 ,
			 psy_stimuli1[i].rect.y + psy_stimuli1[i].rect.height / 2,
			 psy_stimuli1[i].rect.width / 2 , 0 , 2*Math.PI );

		// addlog("-->"+(psy_stimuli1[i].rect.x + psy_stimuli1[i].rect.width / 2))
		ctx.closePath();
		ctx.fill();
		break;

            case 4: /* draw a progress bar, added to 2.7.0 */
		for( j = 0 ; j < psy_pb.item1 ; j++ ){
		    ctx.fillStyle = hexrgb( psy_pb.color1[0],psy_pb.color1[1],psy_pb.color1[2] );
		    ctx.fillRect( psy_stimuli1[i].rect.x + j*psy_pb.itemwidth + j*psy_pb.between ,
				  psy_stimuli1[i].rect.y ,
				  psy_pb.itemwidth , psy_stimuli1[i].rect.height );
		}
		for( j = psy_pb.item1 ; j < psy_pb.item2 ; j++ ){
		    ctx.fillStyle = hexrgb( psy_pb.color2[0],psy_pb.color2[1],psy_pb.color2[2] );
		    ctx.fillRect( psy_stimuli1[i].rect.x + j*psy_pb.itemwidth + j*psy_pb.between ,
				  psy_stimuli1[i].rect.y ,
				  psy_pb.itemwidth , psy_stimuli1[i].rect.height );
		}
		break;

	    case 5: /* draw a movie */
	    /* currently do nothing, it should not be necessary */
		break;

            case 6: /* draw a line */
		ctx.strokeStyle = hexrgb( psy_stimuli1[i].r,psy_stimuli1[i].g,psy_stimuli1[i].b );
		ctx.lineWidth = psy_stimuli1[i].bitmap ; // we use the bitmap field for line width
		ctx.beginPath();
		ctx.moveTo( psy_stimuli1[i].rect.x , psy_stimuli1[i].rect.y ); 
		ctx.lineTo( psy_stimuli1[i].rect.width , psy_stimuli1[i].rect.height ); // we used rect w/h
		ctx.stroke();
		break;
	    }
	}
	i ++ ;
    }

    /* 
    if ( psy_number_sprites > 0 )
    {
	for ( i = 0 ; i < psy_number_sprites ; i ++ )
	{
	    if ( psy_sprites[ i ].visible == 1 )
	    {
		buffer.drawImage( psy_bitmaps[ psy_sprites[ i ].bitmap - 1 ], psy_sprites[i].fg.x , psy_sprites[i].fg.y , null); 
	    }
	}
    }
    */
    //addlog("end psy_draw_all_db()")

}

function psy_add_line( x1 , y1 , x2 , y2 , w , r , g , b ) // NOTE PSY_CENTRAL WOULD BE IGNORED HERE
{
    var tmpx1, tmpy1, tmpx2, tmpy2;

    // add new object
    psy_stimuli1[ psy_stimuli1_end ] = new psy_stimulus1 ;
    psy_stimuli1[ psy_stimuli1_end ].rect = new Rectangle ;

    psy_stimuli1[ psy_stimuli1_end ].x = x1 ;
    psy_stimuli1[ psy_stimuli1_end ].y = y1 ;        
    psy_stimuli1[ psy_stimuli1_end ].type = 6 ; // 6 is line
    psy_stimuli1[ psy_stimuli1_end ].on = 1 ;

    tmpx1 = x1 + psy_screen_x_offset ;
    tmpy1 = y1 + psy_screen_y_offset ;
    tmpx2 = x2 + psy_screen_x_offset ;
    tmpy2 = y2 + psy_screen_y_offset ;
    
    psy_stimuli1[ psy_stimuli1_end ].rect.x = tmpx1 ;
    psy_stimuli1[ psy_stimuli1_end ].rect.y = tmpy1 ;
    psy_stimuli1[ psy_stimuli1_end ].rect.width = tmpx2 ;
    psy_stimuli1[ psy_stimuli1_end ].rect.height = tmpy2 ;
    
    psy_stimuli1[ psy_stimuli1_end ].r = r ;
    psy_stimuli1[ psy_stimuli1_end ].g = g ;
    psy_stimuli1[ psy_stimuli1_end ].b = b ;

    psy_stimuli1[ psy_stimuli1_end ].bitmap = w ; // store the line width in the bitmap field

    psy_stimuli1_n ++ ;
    psy_stimuli1_end ++ ;
    return( psy_stimuli1_end );
}

function psy_add_centered_rectangle_rgb_db(  x ,  y ,  w,  h,  r,  g,  b )
{
    var tmpx; var tmpy;

    // add new object
    psy_stimuli1[ psy_stimuli1_end ] = new psy_stimulus1 ;
    psy_stimuli1[ psy_stimuli1_end ].rect = new Rectangle ;

    psy_stimuli1[ psy_stimuli1_end ].x = x ;
    psy_stimuli1[ psy_stimuli1_end ].y = y ;        
    psy_stimuli1[ psy_stimuli1_end ].type = 0 ; // 0 is rectangle
    psy_stimuli1[ psy_stimuli1_end ].on = 1 ;
    if ( x == PSY_CENTRAL ) tmpx = psy_screen_center_x - w / 2 ; else tmpx = x + psy_screen_x_offset - w / 2;
    if ( y == PSY_CENTRAL ) tmpy = psy_screen_center_y - h / 2 ; else tmpy = y + psy_screen_y_offset - h / 2 ;
    
    psy_stimuli1[ psy_stimuli1_end ].rect.x = tmpx ;
    psy_stimuli1[ psy_stimuli1_end ].rect.y = tmpy ;
    psy_stimuli1[ psy_stimuli1_end ].rect.width = w ;
    psy_stimuli1[ psy_stimuli1_end ].rect.height = h ;
    
    psy_stimuli1[ psy_stimuli1_end ].r = r ;
    psy_stimuli1[ psy_stimuli1_end ].g = g ;
    psy_stimuli1[ psy_stimuli1_end ].b = b ;

    psy_stimuli1_n ++ ;
    psy_stimuli1_end ++ ;
    return( psy_stimuli1_end );
}

function psy_add_centered_circle_rgb_db( x ,  y , radius, r,  g,  b )
{
    var tmpx; var tmpy;

    // add new object
    psy_stimuli1[ psy_stimuli1_end ] = new psy_stimulus1 ;
    psy_stimuli1[ psy_stimuli1_end ].rect = new Rectangle ;

    psy_stimuli1[ psy_stimuli1_end ].x = x ;
    psy_stimuli1[ psy_stimuli1_end ].y = y ;        
    psy_stimuli1[ psy_stimuli1_end ].type = 3 ; // 0=rectangle,1=bitmap,2=text,3=circle
    psy_stimuli1[ psy_stimuli1_end ].on = 1 ;
    if ( x == PSY_CENTRAL ) tmpx = psy_screen_center_x - radius ; else tmpx = x + psy_screen_x_offset - radius ;
    if ( y == PSY_CENTRAL ) tmpy = psy_screen_center_y - radius ; else tmpy = y + psy_screen_y_offset - radius ;
    
    psy_stimuli1[ psy_stimuli1_end ].rect.x = tmpx ;
    psy_stimuli1[ psy_stimuli1_end ].rect.y = tmpy ;
    psy_stimuli1[ psy_stimuli1_end ].rect.width = radius*2 ; 
    psy_stimuli1[ psy_stimuli1_end ].rect.height = radius*2 ;

    
    // addlog("define: x,y=["+x+","+y+"]; topleft=["+tmpx+","+tmpy+"] bottomright=["+(tmpx+radius*2)+","+(tmpy+radius*2)+"]")
    
    psy_stimuli1[ psy_stimuli1_end ].r = r ;
    psy_stimuli1[ psy_stimuli1_end ].g = g ;
    psy_stimuli1[ psy_stimuli1_end ].b = b ;

    psy_stimuli1_n ++ ;
    psy_stimuli1_end ++ ;
    return( psy_stimuli1_end );
}


function psy_add_centered_bitmap_db( number , x , y , r )
{
    var tmpx ; var tmpy;

    // add new object
    psy_stimuli1[ psy_stimuli1_end ] = new psy_stimulus1 ;
    psy_stimuli1[ psy_stimuli1_end ].rect = new Rectangle ;

    psy_stimuli1[ psy_stimuli1_end ].x = x ;
    psy_stimuli1[ psy_stimuli1_end ].y = y ;        
    psy_stimuli1[ psy_stimuli1_end ].R = r ;
    
    psy_stimuli1[ psy_stimuli1_end ].type = 1 ; // 1 is bitmap                                                    
    psy_stimuli1[ psy_stimuli1_end ].on = 1 ;
    psy_stimuli1[ psy_stimuli1_end ].bitmap = number ;

    if ( x == PSY_CENTRAL )
        tmpx = psy_screen_center_x - psy_bitmaps[number-1].width / 2 ;
    else
        tmpx = x + psy_screen_x_offset - psy_bitmaps[number-1].width / 2 ;
    
    if ( y == PSY_CENTRAL )
        tmpy = psy_screen_center_y - psy_bitmaps[number-1].height / 2 ;
    else
        tmpy = y + psy_screen_y_offset - psy_bitmaps[number-1].height / 2 ;
    
    psy_stimuli1[ psy_stimuli1_end ].rect.x      = tmpx ;
    psy_stimuli1[ psy_stimuli1_end ].rect.y      = tmpy ;
    psy_stimuli1[ psy_stimuli1_end ].rect.width  = psy_bitmaps[number-1].width ;
    psy_stimuli1[ psy_stimuli1_end ].rect.height = psy_bitmaps[number-1].height ;

    psy_stimuli1_n ++ ;
    psy_stimuli1_end ++ ;
    return( psy_stimuli1_end );
}

// new in 3.6.2, only internal, for use with "show animation")
// this way, we can have same stimulus with a new bitmap
function psy_replace_bitmap( number , bitmap ){
    psy_stimuli1[ number ].bitmap = bitmap ;
    psy_stimuli1[ number ].rect.width  = psy_bitmaps[ bitmap - 1 ].width ;
    psy_stimuli1[ number ].rect.height = psy_bitmaps[ bitmap - 1 ].height ;
}

// add progress bar
// the progress bar consist of number of items on a bar of total items
// it does not work with percentage

function psy_add_pb( counter , total , x , y , w , h , layout , between , r1,g1,b1,r2,g2,b2 ){

    // add new object
    psy_stimuli1[ psy_stimuli1_end ] = new psy_stimulus1 ;
    psy_stimuli1[ psy_stimuli1_end ].rect = new Rectangle ;

    // if w is not defined, assume default settings
    if ( w == 0 ){
	w = psy_screen_width ;
	h = 5 ;
	y = psy_screen_height/2 * -1 + 3 ; // at top, but not on top (so -3 px)
    }

    psy_pb.item1   = counter ;
    psy_pb.item2   = total   ;

    psy_pb.color1  = [r1,g1,b1] ;
    psy_pb.color2  = [r2,g2,b2] ;
    psy_pb.between = between ;
    psy_pb.layout  = layout ; // currently only 0, horizontal is implemented

    psy_pb.itemwidth = Math.ceil( w / total ) - between ; // the width of one item on the progressbar

    psy_pb.layout  = layout ;

    psy_stimuli1[ psy_stimuli1_end ].x = x ;
    psy_stimuli1[ psy_stimuli1_end ].y = y ;        
    psy_stimuli1[ psy_stimuli1_end ].w = w ;
    psy_stimuli1[ psy_stimuli1_end ].h = h ;        
    psy_stimuli1[ psy_stimuli1_end ].type = 4 ; // 4 is progressbar (pb)
    psy_stimuli1[ psy_stimuli1_end ].on = 1 ;

    psy_stimuli1[ psy_stimuli1_end ].rect.x = x + psy_screen_x_offset - w / 2 ;
    psy_stimuli1[ psy_stimuli1_end ].rect.y = y + psy_screen_y_offset - h / 2 ;
    psy_stimuli1[ psy_stimuli1_end ].rect.width = w ; // the width of the total progess bar (not just one item)
    psy_stimuli1[ psy_stimuli1_end ].rect.height = h ;

    psy_stimuli1_n ++ ;
    psy_stimuli1_end ++ ;
    return( psy_stimuli1_end );
}

function psy_set_coordinate_system( s )
{
    // addlog("set coordinate system: "+psy_screen_x_offset )

    if ( s == 'c' ) // centerzero
    {
	psy_screen_x_offset = psy_screen_center_x ;

	//addlog("set coordinate system: "+psy_screen_x_offset )

	psy_screen_y_offset = psy_screen_center_y ;
    }

    // addlog("set coordinate system: "+psy_screen_x_offset )
}

function Rectangle()
    {
	this.x=0;
	this.y=0;
	this.w=0;
	this.h=0;
    }

function psy_stimulus1()
{
    this.on=0;
    this.type=0;
    this.r=0;
    this.g=0;
    this.b=0;
    this.a=0;
    this.bitmap=0;
    this.x=0;
    this.y=0;
    this.w=0;
    this.h=0;
    this.R=0;
    this.rect=0;
} 

var psy_stimuli1 = new Array;

// // TODO 3.3.0 NOTE: This might be done when creating stimuli rather than in advance.
// for( i = 0 ; i < MAXBITMAPS ; i++ ){
//     psy_stimuli1[i]=new psy_stimulus1 ;
//     psy_stimuli1[i].rect = new Rectangle ;
// }

var psy_stimuli1_n = 0 ; // number of stimuli on screen
var psy_stimuli1_end = 0 ; // length list of stimuli ever shown

function psy_mouse_visibility( visible )
{
    if ( visible == 1 )
    {
	psy_canvas.style.cursor="default";
	psy_mouse_cursor = 1 ; // this is easier than querying the style via javascript/css. This is not how it is done in C.
    }
    else
    {
	psy_canvas.style.cursor="none"; // not supported in all browsers
	psy_mouse_cursor = 0 ;	
    }
}

//////////////////////////////////////////////////////////////////////
//
// EXPERIMENT SPECIFIC FUNCTIONS
//
//////////////////////////////////////////////////////////////////////

/* very close to C and Java code */

var trial_counter; var i;
var trials_left_to_do = 0 ; // this is used if there is more than one task in a block; this is for now used as globabl variable (since 1.9.3)
var tasklist_end_request = 0;
var experiment_end_request = 0;
var Timer_tasklist_begin; var Timer_tasklist_now;
var maxtasklisttime = 0;
var TRIAL_SELECTION_RANDOM = 0;
var TRIAL_SELECTION_RANDOM_NEVER_REPEAT = 1;
var TRIAL_SELECTION_FIXED_SEQUENCE = 2;
var TRIAL_SELECTION_REPEAT_ON_ERROR = 3;
var TRIAL_SELECTION_ONCE = 4;
var TRIAL_SELECTION_EQUAL = 5; // new in 3.4.0
var error_status;	

trial_counter_per_task = new Array(); // 1.9.3 DEBUG TODO: THIS IS NOW DEFINED GLOBAL AND LOCAL, NEED TO FIX
task_probability       = new Array(); // 1.9.3 DEBUG TODO: THIS IS NOW DEFINED GLOBAL AND LOCAL, NEED TO FIX

var blockname = "" ;
var blockrepeat = 1;

var current_trial = new Array();

var current_task = "" // keeps name of current task/block, which is used for jumping back after delay or key
var current_block= ""


function psy_time_since_start(){
    return( new Date().getTime() - psy_exp_start_time )
}

function psy_diff_timers( starttime , endtime ){
    return ( endtime - starttime )
}


// for use in task delays only
function psy_delay( ms ){
    setTimeout( current_task+".run();", ms )
}

// for use in block delays only
function psy_delay_block( ms ){
    setTimeout( current_block+".run();", ms )
}

/* -- psy_choose stuff --------------------------------*/

var psy_chosen_n = 0 ;
var psy_chosen_objects = [] ;

var choose = {
    first: 0, last: 0 ,
    counter1: 0, counter2: 0,
    mouse_select_bitmap: 0,
    mouse_select_bg_bitmap: 0, // TODO, WHAT IS THIS? DOES NOT SEEM NEEDED
    keep: false,
    minselect: 0, /* have to select at least this */
    maxselect: 9999, /* cannot select more than this */
    current_exit_bitmap_num: 0 , // one of two possible bitmaps
    n_selected: 0,
    exit: -1,
    exit_bitmap_1: -1,
    exit_bitmap_2: -1,
    selectedstimuli: [], /* 0 and 1s for no selection, or a number for
			  * the new overlay stimulus on top; this is
			  * the way to keep track of the number of
			  * newly created bitmaps for puting a marker
			  * on top of the selected bitmaps */
    expect_key: 0,
    timer: 0,

    getmouseclick: function( e ){
	if ( choose.expect_key == 1 ){

	    canvas_x_offset = psy_canvas.getBoundingClientRect().left ;
	    canvas_y_offset = psy_canvas.getBoundingClientRect().top	    
	    canvas_w = psy_canvas.getBoundingClientRect().width;
	    canvas_h = psy_canvas.getBoundingClientRect().height;

	    // NOTE: THIS NEEDS CHECKING -- DEBUG
	    tmpmouseX = Math.round( ( e.clientX - canvas_x_offset ) * psy_screen_width / canvas_w ) - psy_screen_x_offset ; // in psytoolkit coordinates
            tmpmouseY = Math.round( ( e.clientY - canvas_y_offset ) * psy_screen_height / canvas_h ) - psy_screen_y_offset ;

	    // is exit bitmap clicked?
	    // addlog("in choose exit "+choose.exit)

	    tmpnum = psy_bitmap_under_mouse(0,choose.current_exit_bitmap_num,choose.current_exit_bitmap_num,
					    tmpmouseX,tmpmouseY)
	    if ( tmpnum == choose.current_exit_bitmap_num &&
		 choose.n_selected >= choose.minselect &&
	         choose.n_selected <= choose.maxselect )
	    {
		choose.stop();
	    }else{
		// any bitmap other than exit under mouse?
		
		tmpnum = psy_bitmap_under_mouse(0,choose.first,choose.last,tmpmouseX,tmpmouseY)
		tmpx = psy_stimuli1[ tmpnum - 1 ].x
		tmpy = psy_stimuli1[ tmpnum - 1 ].y

		if( choose.selectedstimuli[ tmpnum ] == null ){    // it is not yet selected 
		    if ( choose.n_selected < choose.maxselect ){ // add marker
			
			choose.selectedstimuli[tmpnum] = psy_add_centered_bitmap_db( choose.mouse_select_bitmap ,
					       					     tmpx,tmpy );
			choose.n_selected ++ ;
		    }
		}else{ // it is already selected and needs to be unselected
		    psy_clear_stimuli1( choose.selectedstimuli[tmpnum] );
		    choose.selectedstimuli[ tmpnum ] = null ;
		    choose.n_selected -- ;
		}

		// now update exit button, if needed
		if ( choose.n_selected >= choose.minselect && choose.n_selected <= choose.maxselect ){ // can exit?
		    if ( choose.current_exit_bitmap_num == choose.exit_bitmap_2 ){ // this only needs to be done if exit1 is currently not on
			psy_unhide_stimuli1( choose.exit_bitmap_1 );
			psy_clear_stimuli1( choose.exit_bitmap_2 );
			choose.current_exit_bitmap_num = choose.exit_bitmap_1 ;	      
		    }
		}else{ //cannot exit based on how many objects have been selected
		    if ( choose.current_exit_bitmap_num == choose.exit_bitmap_1  ){ // this only needs to be done if exit1 is currently on
			psy_unhide_stimuli1( choose.exit_bitmap_2 );
			psy_clear_stimuli1( choose.exit_bitmap_1 );
			choose.current_exit_bitmap_num = choose.exit_bitmap_2 ;	      	      
		    }
		}
		psy_draw_all_db();
	    }
	}
    },
    timeout: function(){
	// moved this from "stop"
	psy_chosen_n = 0;
	psy_chosen_objects = Array(100).fill(0); //most unlikely more than 100 per trial
	for( i=choose.first ; i <= choose.last ; i++ ){ // TODO: CHECK IF THIS IS < or <=
	    if ( choose.selectedstimuli[i] != null ){
		psy_chosen_objects[ psy_chosen_n ] = i ;
		psy_chosen_n ++ ;
	    }
	}
	//

	window.removeEventListener("mousedown",choose.getmouseclick,false) ; 

	// clear the exit buttons from screen (even with choose.keep==true)
	psy_clear_stimuli1( choose.exit_bitmap_1 ); // in JS, clear and hide are same
	psy_clear_stimuli1( choose.exit_bitmap_2 ); // in JS, clear and hide are same

	// if you do NOT want to keep select indicators, clear them now
	if ( !choose.keep ){
	    // now clear the stimuli drawn in this function
	    for( i = choose.first ; i < choose.last ; i ++ ){  // TODO CHECK (choose.last+1?)
		if ( choose.selectedstimuli[i] != null ){
		    psy_clear_stimuli1( choose.selectedstimuli[i] ) ;
		    // addlog( "cleared: "+choose.selectedstimuli[i] )
		}
	    }
	    psy_stimuli1_n = choose.counter1 ; // returns to the "old" value before "choose" was run
	    psy_stimuli1_end = choose.counter2 ; // returns to the "old" value before "choose" was run	
	}

        psy_draw_all_db();
	choose.expect_key = 0 ;
	choose.maxselect = 9999 ; // set back to its original high value
	// replace eval(current_task+".run()")
	setTimeout( current_task+".run()" , 0 )
    },
    stop: function(){ // stop is like timeout, except for switching of the timer
	keystatus.time = new Date().getTime() - choose.starttime ;
        clearTimeout(choose.timer);
	choose.timeout() ; // now do rest of timeout, including removing just drawn stimuli
    }
}

function psy_choose( maxtime , stimulus_first , stimulus_last , exit1 , exit2 , exit_x, exit_y ){
    keystatus.rt = maxtime ;
    keystatus.time = maxtime ;
    keystatus.status = 3 ;

    // what is the state of stimuli shown now (for later restoration of this state)
    choose.counter1 = psy_stimuli1_n ;
    choose.counter2 = psy_stimuli1_end ;
    // setup the exit bitmaps
    choose.exit_bitmap_1 = psy_add_centered_bitmap_db( exit1 , exit_x , exit_y );
    choose.exit_bitmap_2 = psy_add_centered_bitmap_db( exit2 , exit_x , exit_y );
    psy_clear_stimuli1( choose.exit_bitmap_1 ); // in JS, clear and hide are same
    psy_clear_stimuli1( choose.exit_bitmap_2 ); // in JS, clear and hide are same
    // set some parameters
    choose.expect_key = 1 ;
    choose.n_selected = 0 ;
    choose.first = stimulus_first ;
    choose.last = stimulus_last ;
    choose.selectedstimuli = [] ; /* needs to be cleared */

    /* "unhide" correct exit bitmap */
    if ( choose.n_selected >= choose.minselect && choose.n_selected <= choose.maxselect ){
	psy_unhide_stimuli1( choose.exit_bitmap_1 );
	choose.current_exit_bitmap_num = choose.exit_bitmap_1 ;
    }else{
	psy_unhide_stimuli1( choose.exit_bitmap_2 );
	choose.current_exit_bitmap_num = choose.exit_bitmap_2 ;    
    }
    psy_draw_all_db();
    window.addEventListener("mousedown",choose.getmouseclick,false)
    choose.timer = setTimeout( "choose.timeout()", maxtime); 
    choose.starttime = new Date().getTime()
}

/* -- some plotting functions used in psycc feedback functions ---------------- */

function psy_scale_point_x ( x , realx , realw , xlim1 , xlim2 ){
    xlimrange = xlim2 - xlim1 ;
    rangefactor = realw / xlimrange ; /* how much space per point */
    
    return( realx + ( x - xlim1 ) * rangefactor );
}

function psy_scale_point_y ( y , realy, realh , ylim1 , ylim2 ){
    ylimrange = ylim2 - ylim1 ;
    rangefactor =  realh / ylimrange ; /* how much space per point */
    
    // point 0 is realy+realh
    return( ( realy + realh ) - (y-ylim1) *rangefactor )
}

// the feedback part has its own small paletter of colors 
function psy_palette( colornumber ){
    switch( colornumber )
    {
	case 1: color = "white" ; break; /* white  */
	case 2: color = "red"   ; break; /* red    */
	case 3: color = "green" ; break; /* green  */
	case 4: color = "yellow"; break; /* yellow */
	case 5: color = "blue"  ; break; /* blue   */
    }
    return( color );
}

function psy_plot_xaxis(x, y, w, xlim1, xlim2 ) {
    var i;

    for (i = xlim1; i < xlim2; i++) {
        if (i % 100 == 0) {
            ctx.fillStyle = "white"
            ctx.font = "12px Arial"
            ctx.fillText(i, psy_scale_point_x(i, x, w, xlim1, xlim2) - 10, y + 20)

            ctx.beginPath()
            ctx.moveTo(psy_scale_point_x(i, x, w, xlim1, xlim2), y)
            ctx.lineTo(psy_scale_point_x(i, x, w, xlim1, xlim2), y + 8)
            ctx.stroke()
        } else { // just tickmark
            if (i % 10 == 0) {
                ctx.beginPath()
                ctx.moveTo(psy_scale_point_x(i, x, w, xlim1, xlim2), y)
                ctx.lineTo(psy_scale_point_x(i, x, w, xlim1, xlim2), y + 4)
                ctx.stroke()
            }
        }
    }

}

function psy_plot_yaxis(x, y, w, ylim1, ylim2 ) {
    var i;

    for (i = ylim1; i < ylim2; i++) {
        if (i % 50 == 0) {
            ctx.fillStyle = "white"
            ctx.font = "12px Arial"
            // NOTE the +5 below should actually be improved, because it just is an adjustment
            // for the offset between the letter and the tickmark
            ctx.fillText(i, x - 30, psy_scale_point_y(i, y, w, ylim1, ylim2) + 3)

            ctx.beginPath()
            ctx.moveTo(x - 8, psy_scale_point_y(i, y, w, ylim1, ylim2))
            ctx.lineTo(x, psy_scale_point_y(i, y, w, ylim1, ylim2))
            ctx.stroke()
        } else {
            if (i % 10 == 0) {
                ctx.beginPath()
                ctx.moveTo(x - 4, psy_scale_point_y(i, y, w, ylim1, ylim2))
                ctx.lineTo(x, psy_scale_point_y(i, y, w, ylim1, ylim2))
                ctx.stroke()
            }
        }
    }
}

// e.g., psy_plot_circle(100,100,10,"#FF0000")
function psy_plot_circle( x , y , radius , colorname ){
    ctx.fillStyle = colorname
    ctx.beginPath()
    ctx.arc( x , y , radius , 0 , 2*Math.PI )
    ctx.closePath()
    ctx.fill()
}

// psy_xyplot
// currently ignore box and col

// we need a number sort function, which we then need to use in sort
// in psy_xyplot

function numsort( a , b ){ return( a - b ) ; }
function minimum( a ){ tmp=a.slice();return( tmp.sort(numsort)[0] ) }
function maximum( a ){ tmp=a.slice();return( tmp.sort(numsort)[tmp.length-1] ) }

function psy_xyplot(x, y, w, h, box, col, xdata, ydata, xlabel, ylabel) {

    // set x and y lim and enlarge data points
    // available for plotting should include 
    // sides, so that the actual pixels will fit in
    xlim1 = minimum(xdata) - 10 //you must use minimum, e.g., because .sort
    //changes actual array, rather than
    //returning a new array
    xlim2 = maximum(xdata) + 10
    ylim1 = minimum(ydata) - 10
    ylim2 = maximum(ydata) + 10

    // plot each point
    for (i = 0; i < xdata.length; i++) {
        psy_plot_circle(psy_scale_point_x(xdata[i], x, w, xlim1, xlim2),
			psy_scale_point_y(ydata[i], y, h, ylim1, ylim2), 4, psy_palette(col));
    }

    // plot box around the points
    // ctx.strokeStyle( psy_palette( col ) )
    ctx.beginPath()
    ctx.strokeStyle = psy_palette(col)
    ctx.rect(x, y, w, h)
    ctx.stroke()

    psy_plot_xaxis(x, y + h, w, xlim1, xlim2 );
    psy_plot_yaxis(x, y, h, ylim1, ylim2 );

    // now plot the labels
    ctx.fillStyle = "white"
    ctx.font = "12px Arial"
    ctx.fillText(xlabel, x + w / 2, y + h + 30)

    ctx.save();
    ctx.translate(x - 50 , y + h/2 );
    ctx.rotate(-Math.PI / 2);
    ctx.textAlign = "center";
    ctx.fillText( ylabel , 0 , 0);
    ctx.restore();
}

// in a line plot, there are only y coordinates, plotted from 1 to length of array
function psy_lineplot(   x ,  y ,  w ,  h ,  box ,  ydata ,  colors ,  xlabel , ylabel ){

    xlim1 = 1               - 5
    xlim2 = ydata.length    + 5
    ylim1 = minimum(ydata)  - 10
    ylim2 = maximum(ydata)  + 10

    // plot each point, and lines between them

    previousx = 0
    previousy = 0
    for (i = 0; i < ydata.length; i++) {
	tmpx = psy_scale_point_x(  i, x, w, xlim1, xlim2)
	tmpy = psy_scale_point_y(  ydata[i], y , h , ylim1 , ylim2 )
        psy_plot_circle( tmpx , tmpy , 4, psy_palette(colors[i]));

	if ( i > 0 ){
	    ctx.strokeStyle="white"
	    ctx.beginPath()
	    ctx.moveTo( previousx , previousy )
	    ctx.lineTo( tmpx , tmpy )
	    ctx.stroke()
	}
	previousx = tmpx
	previousy = tmpy
    }

    // plot box around the points
    // ctx.strokeStyle( psy_palette( col ) )
    ctx.beginPath()
    ctx.strokeStyle = "white"
    ctx.rect(x, y, w, h)
    ctx.stroke()

    psy_plot_xaxis(x, y + h, w, xlim1, xlim2 );
    psy_plot_yaxis(x, y, h, ylim1, ylim2 );

    // now plot the labels
    ctx.fillStyle = "white"
    ctx.font = "12px Arial"
    ctx.fillText(xlabel, x + w / 2, y + h + 30)

    ctx.save();
    ctx.translate(x - 50 , y + h/2 );
    ctx.rotate(-Math.PI / 2);
    ctx.textAlign = "center";
    ctx.fillText( ylabel , 0 , 0);
    ctx.restore();
}

/* -- end of plotting functions used in psycc feedback functions ---------------- */

/* -- fullscreen functions (not necessary in C, currently as of version 2.0.11 */

// note: Safari does not allow fullscreen+keyboard

function psy_fullscreen( o ){ /* is object to be made fullscreen, should be canvasbox */
    if(o.requestFullScreen) o.requestFullScreen("hide")
    else if(o.webkitRequestFullScreen) o.webkitRequestFullScreen(psy_canvas.ALLOW_KEYBOARD_INPUT) /* note c is global var for canvas object */
    else if(o.mozRequestFullScreen) o.mozRequestFullScreen()
    else if(o.msRequestFullscreen)o.msRequestFullscreen();
}

// new in 3.3.2
function psy_screen_scale(s = 0, fullscreen = false) { //s=0:no,s=1 scale and keep aspect ration, s=2,stretch if needed)
    //console.log("scale s="+s);
    var scalex = 1;
    var scaley = 1;
    var cb = document.getElementById('cbox');
    var xx = document.getElementById('exp');

    //console.log("frame = "+psy_frame_w+" "+psy_frame_h);

    if (fullscreen || document.fullscreenElement || document.webkitFullscreenElement ) { // if already in fullscreen, then also scale to fullscreen (can happen if clicked before experiment starts)
        scalex = window.screen.width / psy_screen_width;
        scaley = window.screen.height / psy_screen_height;
	cb.style.width = parseInt(window.screen.width)+"px";
	cb.style.height = parseInt(window.screen.height)+"px";
	cb.style.overflow="hidden";
    } else {
	cb.style.width=psy_frame_w+"px";
	cb.style.height=psy_frame_h+"px";
	cb.style.overflow="hidden";
	cb.style.display='flex'; // this needs to be reset each time following change apparently
	cb.style.alignItems='center';
	cb.style.justifyContent='center';
        scalex = parseInt(cb.style.width) / psy_screen_width;
        scaley = parseInt(cb.style.height) / psy_screen_height;
    }

    if (s == 1)
        xx.style.transform = 'scale(' + Math.min(scalex, scaley).toFixed(2) + ',' + Math.min(scalex, scaley).toFixed(2) + ')';

    if (s == 2)
        xx.style.transform = 'scale(' + Math.min(scalex).toFixed(2) + ',' + Math.min(scaley).toFixed(2) + ')';
}

function psy_exit_fullscreen(){
    if(document.exitFullScreen) document.exitFullScreen();
    else if(document.webkitCancelFullScreen)document.webkitCancelFullScreen();
    else if(document.mozCancelFullScreen)document.mozCancelFullScreen();
    else if(document.msExitFullscreen)document.msExitFullscreen();
}

/* ---------------------------------------------- */

function psy_rotate_existing_stimulus( number , r ){
    if ( number < 0 )
	tmp = psy_stimuli1_end + number ;
    else
	tmp = number - 1;

    psy_stimuli1[ tmp ].R = r ;
}

function psy_relocate_existing_stimulus( number , x , y ){
    var x,y,w,h;

    if ( number < 0 )
	tmp = psy_stimuli1_end + number ;
    else
	tmp = number - 1;

    psy_stimuli1[ tmp ].x = x ;
    psy_stimuli1[ tmp ].y = y ;

    w = psy_stimuli1[ tmp ].rect.width ;
    h = psy_stimuli1[ tmp ].rect.height ;

    if ( x == PSY_CENTRAL ) tmpx = psy_screen_center_x - w / 2 ; else tmpx = x + psy_screen_x_offset - w / 2 ;
    if ( y == PSY_CENTRAL ) tmpy = psy_screen_center_y - h / 2 ; else tmpy = y + psy_screen_y_offset - h / 2 ;

    psy_stimuli1[ tmp ].rect.x = tmpx ;
    psy_stimuli1[ tmp ].rect.y = tmpy ;
}

function psy_move_existing_stimulus( number , relative_x , relative_y ){
    var x,y,w,h;

    if ( number < 0 )
	tmp = psy_stimuli1_end + number ;
    else
	tmp = number - 1;

    psy_stimuli1[ tmp ].x = psy_stimuli1[ tmp ].x + relative_x ;
    psy_stimuli1[ tmp ].y = psy_stimuli1[ tmp ].y + relative_y ;

    x = psy_stimuli1[ tmp ].x ;
    y = psy_stimuli1[ tmp ].y ;
    w = psy_stimuli1[ tmp ].rect.width ;
    h = psy_stimuli1[ tmp ].rect.height ;

    if ( x == PSY_CENTRAL ) tmpx = psy_screen_center_x - w / 2 ; else tmpx = x + psy_screen_x_offset - w / 2 ;
    if ( y == PSY_CENTRAL ) tmpy = psy_screen_center_y - h / 2 ; else tmpy = y + psy_screen_y_offset - h / 2 ;

    psy_stimuli1[ tmp ].rect.x = tmpx ;
    psy_stimuli1[ tmp ].rect.y = tmpy ;
}

/* --------------------------------------------- */
/* All rate (rating scale) code                  */
/* similarly programmed as psy_choose            */

var rate = {
    first: 0, last: 0 , // the first and last item on scale
    rt: 0, status: 0, selected: -1,
    counter1: 0, counter2: 0, // storage for psy_stimuli1_n and psy_stimuli_end
    //mouse_select_bitmap: 0,
    //mouse_select_bg_bitmap: 0, // TODO, WHAT IS THIS? DOES NOT SEEM NEEDED
    keep: false,
    exit: -1,
    left_bitmap: 0,
    right_bitmap: 0,
    item_bitmap: 0,
    between_px: 20,
    expect_key: 0,
    timer: 0,

    getmouseclick: function( e ){
	if ( rate.expect_key == 1 ){

	    canvas_x_offset = psy_canvas.getBoundingClientRect().left ;
	    canvas_y_offset = psy_canvas.getBoundingClientRect().top	    
	    canvas_w = psy_canvas.getBoundingClientRect().width;
	    canvas_h = psy_canvas.getBoundingClientRect().height;

	    // NOTE: THIS NEEDS CHECKING -- DEBUG
	    tmpmouseX = Math.round( ( e.clientX - canvas_x_offset ) * psy_screen_width / canvas_w ) - psy_screen_x_offset ; // in psytoolkit coordinates
            tmpmouseY = Math.round( ( e.clientY - canvas_y_offset ) * psy_screen_height / canvas_h ) - psy_screen_y_offset ;

	    tmpnum = psy_bitmap_under_mouse(0,rate.first,rate.last,tmpmouseX,tmpmouseY)
	    tmpx = psy_stimuli1[ tmpnum - 1 ].x
	    tmpy = psy_stimuli1[ tmpnum - 1 ].y

	    if ( tmpnum >= rate.first && tmpnum <= rate.last )
	    {
		rate.selected = tmpnum - rate.first + 1
		rate.expect_key = 0 ;
		rate.stop();
	    }
	}
    },
    timeout: function(){
	window.removeEventListener("mousedown",rate.getmouseclick,false) ; 
	if ( !rate.keep ){
	    // now clear the stimuli drawn in this function
	    for( i = (rate.counter2+1) ; i <= rate.last ; i ++ ){
		psy_clear_stimuli1( i ) ;
	    }
	    psy_stimuli1_n = rate.counter1 ; // returns to the "old" value before "rate" was run
	    psy_stimuli1_end = rate.counter2 ; // returns to the "old" value before "rate" was run	
	}

        psy_draw_all_db();
	rate.expect_key = 0 ;
	psy_restore_mouse();
	setTimeout( current_task+".run()" , 0 )
    },
    stop: function(){ // stop is like timeout, except for switching off the timer
	rate.rt = new Date().getTime() - rate.starttime ;
	rate.status = 1 ;
        clearTimeout(rate.timer);
	rate.timeout() ; // now do rest of timeout, including removing just drawn stimuli
    }
}

function psy_rate_go( xpos , ypos , maxtime , items ){
    // set default values
    rate.rt = 0 ; // default is 0
    rate.selected = -1 ;
    rate.status = 3 ; // default is timeout, unless set to 1 by rate::stop()
    // make sure mouse is on
    psy_store_mouse();
    psy_mouse_visibility(1);
    // what is the state of stimuli shown now (for later restoration of this state)
    rate.counter1 = psy_stimuli1_n ;
    rate.counter2 = psy_stimuli1_end ;
    /* calculate dimensions of rate scale on screen */
    // width of items itself, depends on whether default of user bitmaps are used
    if ( rate.item_bitmap == 0 ){
	itemwidth=20 // radius of circle 20 is set below
    }else{
	itemwidth=psy_bitmaps[rate.item_bitmap-1].width
    }

    if ( rate.left_bitmap == 0 ){
	scaleW = itemwidth*items + rate.between_px * (items-1)
    }else{
	scaleW = itemwidth*items + rate.between_px * (items-1)
    }

    /* show rating scale on the screen */
    /* the left and right bitmaps */
    if ( rate.left_bitmap == 0 ){
  	psy_add_centered_rectangle_rgb_db( xpos - (scaleW/2 + 15 + rate.between_px),
					   ypos , 30 , 30 ,  255,255,255 );
	psy_add_centered_rectangle_rgb_db( xpos + scaleW/2 + 15 + rate.between_px ,
					   ypos , 30 , 30 ,  255,255,255 );
    }else{
	psy_add_centered_bitmap_db( rate.left_bitmap ,
				    xpos - (scaleW/2 + psy_bitmaps[rate.left_bitmap-1].width/2 + rate.between_px), ypos , 0 );
	psy_add_centered_bitmap_db( rate.right_bitmap ,
				    xpos + scaleW/2 + psy_bitmaps[rate.right_bitmap-1].width/2 + rate.between_px, ypos , 0 );
    }

    /* show the different points on the scale */
    rate.first = psy_stimuli1_end + 1 ;
    for( i = 0 ; i < items ; i++ ){
	if ( rate.item_bitmap == 0 ){
	    psy_add_centered_circle_rgb_db( xpos-(scaleW/2)+i*(rate.between_px+itemwidth)+itemwidth/2 , ypos , 10 , 255,255,0)
	}else{
	    psy_add_centered_bitmap_db( rate.item_bitmap ,
					xpos-(scaleW/2)+i*(rate.between_px+itemwidth)+itemwidth/2 , ypos ,0 );
	}
    }
    rate.last = psy_stimuli1_end ;
    psy_draw_all_db();

    /* now that is all on the screen, handle the mouse */

    rate.expect_key = 1 ; /* keep track if mouse has been clicked on item */

    window.addEventListener("mousedown",rate.getmouseclick,false);
    rate.timer = setTimeout( "rate.timeout()", maxtime); 
    rate.starttime = new Date().getTime();
}

//////////////////////////////////////////////////////////////////////
// following two functions just to start online experiment
// TODO TO TEST 1/5/2018

function start_exp_setup(){

    console.log("w h = "+psy_screen_width+" "+psy_screen_height);
    psy_screen_scale();

    // rectangle width= 450x350
    topX = psy_screen_width  - (psy_screen_width / 2)  - 450/2 ;
    topY = psy_screen_height - (psy_screen_height / 2) - 350/2 ;
    botX = psy_screen_width  - (psy_screen_width / 2)  + 450/2 ;
    botY = psy_screen_height - (psy_screen_height / 2) + 350/2 ;
    //

    tmp1 = document.getElementById('exp') ;
    tmp2 = tmp1.getContext('2d') ;

    tmp2.fillStyle=`rgb(${psy_startbutton_color.join(',')})` ;

    tmp2.fillRect(topX,topY,450,350) ;
    tmp2.fillStyle='yellow' ;
    tmp2.font='24px Arial' ;
    tmp2.textAlign='center' ;

    // note: psy_startbutton_text will be set in psycc (but have some insurance)
    if ( !psy_startbutton_text ) psy_startbutton_text = "Click to start ..." ;

    tmp2.fillText(psy_startbutton_text,psy_screen_width/2,psy_screen_height/2) ;

    // TODO: note, the tmpmouse function is created in survey-classes.rb
    // in the future, you might also define it here
    window.addEventListener('mousedown', tmpmouse, false); ScreenStartTime=new Date().getTime();
}

// function psy_array_shuffle( a ){
//     var array = Array.from(a) ;
//     array.sort(()=>Math.random()-0.5);
//     return( array );
// }

// https://medium.com/@omar.rashid2/fisher-yates-shuffle-a2aa15578d2f

function psy_array_shuffle( a ){
    var array = Array.from(a) ;
    var oldElement;

    for (let i = array.length - 1; i > 0; i--) {
	let rand = Math.floor(Math.random() * (i + 1));
	oldElement = array[i];
	array[i] = array[rand];
	array[rand] = oldElement;
    }

    return( array );
}



function psy_array_shuffle_no_repeats(array){
    var a , n , i , counter = 0 ;
    var tmpout = [] ; // the to-be-created array
    var try_outs = 0 ; // tried to find solution so far from beginning
    var no_solution = 1 ; // 1 if no solution found

    const MAXTRIES = 10 ; // how many times cycling for finding a solution

    while ( try_outs < MAXTRIES && no_solution == 1 ){
	no_solution = 0 ; // start with positive value; if no solution is found, this will be set to 1
	a = Array.from(array);
	n = a.length
	tmpout.length = 0 ; // reset each time

	for( i = 0 ; i < n ; i++ ){
	    counter = 0 ;
	    r = Math.floor(Math.random() * ( n - i ) ) ;
	    if ( i > 0 ){
		while ( a[r] == tmpout[i-1] && counter < MAXTRIES ){
		    r = Math.floor(Math.random() * ( n - i ) ) ;
		    counter++ ; }}

	    if ( counter == MAXTRIES ){
		no_solution = 1 ;
	    }
	    tmpout.push( a[r] )
	    a.splice( r , 1 )
	}
	if ( no_solution == 1 ) try_outs++ ;
    }
    if ( try_outs == MAXTRIES ) tmpout = psy_array_shuffle( array ); // if no solution, do "normal" shuffle
    return( tmpout );
}

// repeats. 1=no direct repeat, 2 is no repeat 2 off, etc
// this is useful for creating matrices for stimuli

function psy_array_shuffle_no_x_repeats(array,repeats){
    var a , n , i , j, counter = 0 ;
    var tmpout = [] ; // the to-be-created array
    var try_outs = 0 ; // tried to find solution so far from beginning
    var no_solution = 1 ; // 1 if no solution found
    var repeat_matrix = [] ;

    const MAXTRIES = 10 ; // how many times cycling for finding a solution

    while ( try_outs < MAXTRIES && no_solution == 1 ){
	no_solution = 0 ; // start with positive value; if no solution is found, this will be set to 1
	a = Array.from(array);
	n = a.length
	tmpout.length = 0 ; // reset each time

	for( i = 0 ; i < n ; i++ ){
	    counter = 0 ;
	    r = Math.floor(Math.random() * ( n - i ) ) ;

	    // now get new value, and try again and again if not correct one
	    if ( i > 0 ){
		repeat_matrix = [];
		for( j=0;j<repeats.length;j++ )
		    if ( repeats[j] <= i ) repeat_matrix.push(tmpout[ i - repeats[j] ] ) ;

		while ( repeat_matrix.includes( a[r] ) && counter < MAXTRIES ){
		    r = Math.floor(Math.random() * ( n - i ) ) ;
		    counter++ ; }}

	    if ( counter == MAXTRIES ){
		no_solution = 1 ;
	    }
	    tmpout.push( a[r] )
	    a.splice( r , 1 )
	}
	if ( no_solution == 1 ) try_outs++ ;
    }
    if ( try_outs == MAXTRIES ) tmpout = psy_array_shuffle( array ); // if no solution, do "normal" shuffle
    return( tmpout );
}

//a=psy_array_shuffle_no_x_repeats([ 1,2,3,4,5,6,7,8,1,2,3,4,5,6,7,8],[1,4])
//print=function(x){console.log(x)}
//print(a.slice(0,4));print(a.slice(4,8));print(a.slice(8,12));print(a.slice(12,16))


function psy_array_remove_value( a , value ){
    var count ;
    var tmpout = [] ;
    for ( count = 0 ; count < a.length ; count++ )
	if ( a[count] != value ) tmpout.push( a[count] ) ;
    return( tmpout );
}

function psy_array_uniq( a ){
    var tmpout = [] ;
    for( i=0 ; i < a.length ; i++ ) if ( !tmpout.includes(a[i]) ) tmpout.push(a[i])
    return(tmpout);
}

// find index of (first) value (or 0)
function psy_array_locate( a , value ){
    var i = 0 ;
    var found = false ;

    while(  i < a.length && found == false ){
	if ( a[i] == value )
	    found = true ;
	else
	    i++;
    }
    if ( i == a.length )
	return(0);
    else
	return(i+1);
}

// fill array with n random values between low and high
// TODO: later add no-repeat function if useful
function psy_array_fill_random( low , high , n ){
    var tmpout=[];
    var i=0;
    for( i=0 ; i<n ; i++ ) tmpout.push( psy_random( low , high ) );
    return( tmpout );
}

// sample n items from array a 
function psy_array_sample_from( a , n ){
    var tmparray = Array.from(a) ;
    var tmpout=[];
    var i=0;
    for( i=0 ; i<n ; i++ ) tmpout.push( tmparray.splice( Math.floor(Math.random() * tmparray.length ) ,1 )[0] );
    return( tmpout );
}

// check if two arrays are equal (0->not equal,1->equal)
function psy_arrays_equal( a1 , a2 ){
    return( JSON.stringify(a1)===JSON.stringify(a2)?1:0 );
}

// compare two arrays and return how many elements match the other array exactly at same index location
function psy_count_match_array( a1 , a2 ){
    var shortest = Math.min( a1.length , a2.length ) ;
    var i , tmp = 0 ;
    for( i = 0 ; i < shortest ; i++ ) if ( a1[i] == a2[i] ) tmp ++ ;
    return( tmp )
}

function psy_array_mean( a ){
    var total = 0  ;
    for( var i=0 ; i < a.length ; i++ ) total = total + a[i] ;
    return( total / a.length )
}

function psy_array_median( a ){
    tmparray = a.sort((a,b)=>a-b);
    var mid = tmparray.length / 2;
    return mid % 1 ? tmparray[mid - 0.5] : (tmparray[mid - 1] + tmparray[mid]) / 2;
}

function psy_array_sum( a ){
    var total = 0  ;
    for( var i=0 ; i  < a.length ; i++ ) total = total + a[i] ;
    return( total )
}

function psy_array_sd( a ){
    var total = 0 ;
    var tmpmean = psy_array_mean( a );
    for( var i = 0 ; i < a.length ; i++ ) total = total + Math.pow( a[i] - tmpmean , 2 ) ;
    return( Math.sqrt( total / a.length ) );
}

function psy_array_sd1( a ){
    var total = 0 ;
    var tmpmean = psy_array_mean( a );
    for( var i = 0 ; i < a.length ; i++ ) total = total + Math.pow( a[i] - tmpmean , 2 ) ;
    return( Math.sqrt( total / ( a.length - 1 ) ) );
}


//////////////////////////////////////////////////////////
// new in 3.3.0
// this sets up the mouse listeners and timers

function psy_start_drag( fromarray , toarray , snap , ghost , maxrt ){
    psy_drag.starttime = new Date().getTime();
    psy_drag.fromarray = Array.from( fromarray ) ;
    psy_drag.toarray = Array.from( toarray );
    psy_drag.snap = snap ;
    psy_drag.ghost = ghost ;
    psy_drag.maxrt = maxrt ;
    psy_drag.changed = 0 ; // need to (re)set this to default
    psy_drag.mousedowneventlistener = true ;
    psy_drag.lasttask = current_task ;
    window.addEventListener("mousedown",getmousedowndrag,false); // used to be true (changed on 20/11/2020), to check
    psy_drag.mousedowneventlistener=true;
    psy_drag.timer = setTimeout( psy_drag.timeout , maxrt );
}

// psy_start_dragging starts a multiple dragging period

function psy_start_dragging( fromarray , toarray , snap , ghost , maxrt , exit_stimulus ){
    psy_drag.dragging = true ;
    psy_drag.starttime = new Date().getTime();
    psy_drag.fromarray = [fromarray , exit_stimulus ].flat();  // we add the exit_stimulus to the to array, but only for checking it
    psy_drag.toarray = Array.from(toarray) ;
    psy_drag.snap = snap ;
    psy_drag.ghost = ghost ;
    psy_drag.maxrt = maxrt ;
    psy_drag.exit = exit_stimulus ;
    psy_drag.changed = 0 ; // need to (re)set this to default
    psy_drag.mousedowneventlistener = true ;
    psy_drag.lasttask = current_task ;
    window.addEventListener("mousedown",getmousedowndrag,false); // changed to false on 20/11/2020, to check
    psy_drag.timer = setTimeout( psy_drag.timeout_dragging , maxrt );
}

// new in 3.3.0
// xalign: no,left,center,right ; yalign: no,top,center,bottom ; overlap: 0/1
// change stim1
// if no_overlap_direction of stacking (0=no,-1=left or top,1=right or bottom)
function psy_stimuli_align( stim1 , stim2 , xalign, yalign, overlap , no_overlap_array , x_stack , y_stack ){

    var newx=0,newy=0,tmps=0,no_overlap_found=false , align_x_offset = 0 , align_y_offset=0;

    if ( overlap == 0 ){
	switch(xalign){
	case 0:
	    newx = psy_stimuli1[ stim1 - 1].x;
	    break;
	case 1:
	    newx = Math.trunc( psy_stimuli1[ stim2 - 1].x - psy_stimuli1[ stim2 - 1].rect.width/2 + psy_stimuli1[ stim1 - 1].rect.width / 2 ) ;
	    break;
	case 2:
	    newx = psy_stimuli1[ stim2 - 1].x;
	    break;
	case 3:
	    newx = Math.trunc( psy_stimuli1[ stim2 - 1].x + psy_stimuli1[ stim2 - 1].rect.width/2 - psy_stimuli1[ stim1 - 1].rect.width / 2 );
	    break;
	}

	switch(yalign){
	case 0:
	    newy = psy_stimuli1[ stim1 - 1].y;
	    break;
	case 1:
	    newy = Math.trunc( psy_stimuli1[ stim2 - 1].y - psy_stimuli1[ stim2 - 1].rect.height/2 + psy_stimuli1[ stim1 - 1].rect.height / 2 ) ;
	    break;
	case 2:
	    newy = psy_stimuli1[ stim2 - 1].y;
	    break;
	case 3:
	    newy = Math.trunc( psy_stimuli1[ stim2 - 1].y + psy_stimuli1[ stim2 - 1].rect.height/2 - psy_stimuli1[ stim1 - 1].rect.height / 2 ) ;
	    break;
	}
    }

    while( no_overlap_found == false ){
	if ( overlap == 1 ){
	    switch(xalign){
	    case 0:
		newx = psy_stimuli1[ stim1 - 1].x;
		break;
	    case 1:
		newx = Math.trunc( psy_stimuli1[ stim2 - 1].x - psy_stimuli1[ stim2 - 1].rect.width/2 + psy_stimuli1[ stim1 - 1].rect.width / 2 + align_x_offset );
		break;
	    case 2:
		newx = psy_stimuli1[ stim2 - 1].x + align_x_offset ;
		break;
	    case 3:
		newx = Math.trunc( psy_stimuli1[ stim2 - 1].x + psy_stimuli1[ stim2 - 1].rect.width/2 - psy_stimuli1[ stim1 - 1].rect.width / 2 + align_x_offset );
		break;
	    }
	    
	    switch(yalign){
	    case 0:
		newy = psy_stimuli1[ stim1 - 1].y;
		break;
	    case 1:
		newy = Math.trunc( psy_stimuli1[ stim2 - 1].y - psy_stimuli1[ stim2 - 1].rect.height/2 + psy_stimuli1[ stim1 - 1].rect.height / 2 + align_y_offset );
		break;
	    case 2:
		newy = psy_stimuli1[ stim2 - 1].y + align_y_offset ;
		break;
	    case 3:
		newy = Math.trunc( psy_stimuli1[ stim2 - 1].y + psy_stimuli1[ stim2 - 1].rect.height/2 - psy_stimuli1[ stim1 - 1].rect.height / 2 + align_y_offset );
		break;
	    }
	}

	// now check if there is a stimulus underneath
	tmps = psy_bitmap_under_mouse_in_range( no_overlap_array , newx , newy );
	if ( tmps == 0 ){
	    no_overlap_found = true ;
	}else{
	    align_y_offset = align_y_offset + psy_stimuli1[ tmps - 1 ].rect.height * y_stack ;
	    align_x_offset = align_x_offset + psy_stimuli1[ tmps - 1 ].rect.width * x_stack ;
	}
    }

    psy_relocate_existing_stimulus( stim1 , newx , newy );
}

// psy_delete_stimulus deletes the last stimulus created and reset
// counters as if it never existed (needed for some functions, such as
// drag-drop)

function psy_delete_last_stimulus(){
    if ( psy_stimuli1[ psy_stimuli1_end - 1 ].on == 1 ) psy_stimuli1_n -- ;
    psy_stimuli1_end -- ;
    return( psy_stimuli1_end );
}

// psy_copy_stimulus creates a new stimulus based on an old one. Used by drag and drop

function psy_copy_stimulus( number ){

    if ( number < 0 )
	tmp = psy_stimuli1_end + number ; /* plus sign, because number is negative */
    else
	tmp = number - 1 ;

    psy_stimuli1[ psy_stimuli1_end ] = Object.assign( {} , psy_stimuli1[ tmp ] ) ;

    if ( psy_stimuli1[ psy_stimuli1_end ].on == 1 ) psy_stimuli1_n ++ ;
    psy_stimuli1_end ++ ;
    return( psy_stimuli1_end );
}

// for text variables ruby style indeces
// index starts with 1. Last is -1
// for example, psy_substr("1234",1,-1) returns 1234

function psy_substr( text , first , last ){
    var t,f,l ; // t=tmp,f=first,l=last ; temporarily helper variables

    if ( text.length == 0 ) return( "" ); // this should not realy happen

    if ( last == undefined ){ // in case just called with only "first", returns one character
	if ( first < 0 ){
	    t = text.length + first ;
	    // returns as intended or return last (when the index does not really exist)
	    if ( t > 0 ) return( text[t] ) ; else return(text[0]) ;
	}else
	    if ( first <= text.length ) return( text[first-1] ); else return( text[text.length-1] );
    }else{ // returns substring
	if ( first < 0 ) f = text.length + first ; else f = first - 1 ;
	if ( last < 0 ) l = text.length + last + 1 ; else l = last ;
	return(text.substring(f,l));
    }
}

// fill up or cut to max value

function psy_fillup( a , n , value ){
    if ( a.length < n ){
	return(a.concat( Array( n - a.length ).fill(value)));
    }else{
	return(a.slice(0,n));
    }
}

// new function. In case there is video to upload, check this first. Xhrcounter is set by psycc (to 0 if not files needed upload)

var xhruploader = "" ;

function psy_submitWhenReady(){
    if ( xhrcounter > 0 ){
	// clear screen first
	ctx.fillStyle = hexrgb(0,0,0);
	ctx.fillRect(0,0,psy_screen_width,psy_screen_height);
	// now show the uploader message
	tmp1 = document.getElementById('exp');
	tmp2 = tmp1.getContext('2d');
	tmp2.fillStyle='yellow';
	tmp2.font='24px Arial';
	tmp2.textAlign='center';
	xhruploader+="|";
	tmp2.fillText("Uploading data "+xhruploader,200,200);
        setTimeout( psy_submitWhenReady , 1000 );
    }else{
	document.mainform.submit();
    }
}

// rounding to decimals

function psy_round( number , decimals ){
    const factor = Math.pow( 10 , decimals ) ;
    return Math.round( number * factor ) / factor ;
}
var instructions = 1 ;
var small = 2 ;
var big = 3 ;

/* global variables in tasks, blocks, and feedback */
var congruentTrials = 0 ;
var incongruentTrials = 0 ;
var conditionName = 0 ;
var conditionName = 0 ;
var conditionName = 0 ;
var conditionName = 0 ;
/* array variables in tasks, blocks, and feedback */
var a = [] ;
/* done with script codes' global and local variables definitions */
var psy_startbutton_text = "Click to start";
var psy_startbutton_color = [255, 0, 0];
var psy_loading_text = "Loading data ...";
/* global timestamp variables in tasks */
var general_trial_counter = 0 ;


/* TASK: sce -------------------*/
var task_sce = { step:1, task_trial_selection:0, current_trial: -1, taskname: "task_sce",tasknumber:1,
start: function(condition){ task_sce.step=1;
psy_clear_stimulus_counters_db();psy_stop_freqs();task_sce.run();},
leftNumber: 0,
rightNumber: 0,
leftright: 0,
leftfont: 0,
rightfont: 0,
correctResponse: 0,
conditionNumber: 0,
run: function(){
current_task = task_sce.taskname ; 
switch( task_sce.step ){
case 1:
task_sce.step++;
general_trial_counter++ ;
task_sce.leftNumber = task_sce.rightNumber = task_sce.leftright = task_sce.leftfont = task_sce.rightfont = task_sce.correctResponse = task_sce.conditionNumber = 0 ; /* init local variables */
error_status=0; /* because there is a table, this must be after table TRIAL SELECTION stuff */
task_sce.leftNumber = 
psy_random(1 , 9 );
a.length=0;for(tmppsy=1;tmppsy <= 9;tmppsy++)a.push(tmppsy);
a.splice( task_sce.leftNumber - 1 , 1 );
task_sce.rightNumber = a[ Math.floor(Math.random() * a.length ) ] ;
task_sce.leftright = 
psy_random(1 , 2 );
if ( task_sce.leftright == 1 ){
task_sce.leftfont = 2 ; 
task_sce.rightfont = 3 ; 
task_sce.correctResponse = 5 ; 
}else{
task_sce.leftfont = 3 ; 
task_sce.rightfont = 2 ; 
task_sce.correctResponse = 3 ; 
}
if ( task_sce.leftNumber<task_sce.rightNumber && task_sce.leftfont == 2 ){
conditionName = "congruent" ; 
task_sce.conditionNumber = 1 ; 
}
if ( task_sce.leftNumber<task_sce.rightNumber && task_sce.leftfont == 3 ){
conditionName = "incongruent" ; 
task_sce.conditionNumber = 2 ; 
}
if ( task_sce.leftNumber>task_sce.rightNumber && task_sce.leftfont == 2 ){
conditionName = "incongruent" ; 
task_sce.conditionNumber = 2 ; 
}
if ( task_sce.leftNumber>task_sce.rightNumber && task_sce.leftfont == 3 ){
conditionName = "congruent" ; 
task_sce.conditionNumber = 1 ; 
}
psy_add_centered_rectangle_rgb_db(0,0,100,10,0,0,0);
psy_add_centered_rectangle_rgb_db(0,0,10,100,0,0,0);
psy_draw_all_db();
psy_delay( 500 );
break;
case 2:
task_sce.step++;
psy_clear_stimuli1(-1);
psy_clear_stimuli1(-2);
psy_draw_all_db();
psy_current_font = task_sce.leftfont ;
psy_add_centered_rectangle_rgb_db(-200,0,200,200,238,238,238);
psy_add_text_rgb_db( psy_current_font , -200,0, PSY_CENTRAL, PSY_CENTRAL, 0, 0, 0, task_sce.leftNumber , 0 );
psy_draw_all_db();
psy_current_font = task_sce.rightfont ;
psy_add_centered_rectangle_rgb_db(200,0,200,200,238,238,238);
psy_add_text_rgb_db( psy_current_font , 200,0, PSY_CENTRAL, PSY_CENTRAL, 0, 0, 0, task_sce.rightNumber , 0 );
psy_draw_all_db();
psy_mouse_click_bitmap_rectangle_range( 'l',task_sce.correctResponse,3000,3,6);
break;
case 3:
task_sce.step++;
psy_clear_stimuli1(-1);
psy_clear_stimuli1(-2);
psy_draw_all_db();
psy_current_font = small ;
if ( ! ( keystatus.status == 1 ) ){ task_sce.step=6 }; task_sce.run();
break;
case 4:
task_sce.step++;
psy_add_text_rgb_db( psy_current_font , PSY_CENTRAL,PSY_CENTRAL, PSY_CENTRAL, PSY_CENTRAL, 0, 0, 0, "Well done" , 0 );
psy_draw_all_db();
psy_delay( 500 );
break;
case 5:
task_sce.step++;
task_sce.run();
break;
case 6:
task_sce.step++;
if ( ! ( keystatus.status == 2 ) ){ task_sce.step=10 }; task_sce.run();
break;
case 7:
task_sce.step++;
psy_add_text_rgb_db( psy_current_font , PSY_CENTRAL,PSY_CENTRAL, PSY_CENTRAL, PSY_CENTRAL, 0, 0, 0, "Wrong" , 0 );
psy_draw_all_db();
psy_current_font = instructions ;
psy_add_text_rgb_db( psy_current_font , 0,100, PSY_CENTRAL, PSY_CENTRAL, 0, 0, 0, "Press A if left number is physically larger" , 0 );
psy_draw_all_db();
psy_delay( 1500 );
break;
case 8:
task_sce.step++;
psy_add_text_rgb_db( psy_current_font , 0,200, PSY_CENTRAL, PSY_CENTRAL, 0, 0, 0, "Press L if right number is physically larger" , 0 );
psy_draw_all_db();
psy_delay( 2000 );
break;
case 9:
task_sce.step++;
task_sce.run();
break;
case 10:
task_sce.step++;
if ( ! ( keystatus.status == 3 ) ){ task_sce.step=13 }; task_sce.run();
break;
case 11:
task_sce.step++;
psy_add_text_rgb_db( psy_current_font , PSY_CENTRAL,PSY_CENTRAL, PSY_CENTRAL, PSY_CENTRAL, 0, 0, 0, "Too slow" , 0 );
psy_draw_all_db();
psy_delay( 1000 );
break;
case 12:
task_sce.step++;
task_sce.run();
break;
case 13:
task_sce.step++;
psy_clear_screen_db();
psy_delay( 500 );
break;
case 14:
task_sce.step++;
addoutput(eval('blocks'+psy_blockorder+'.blocknumber')+' '+'"'+conditionName+'"'+' '+task_sce.conditionNumber+' '+keystatus.time+' '+keystatus.status+' '+task_sce.leftNumber+' '+task_sce.rightNumber+' '+task_sce.leftfont);
setTimeout(current_block+".run()",0)
break;
}}}
/* block name: training ----------------------- */
var block_training = {
blockname: "block_training", step: 1, trial_counter: 0,
trial_counter_per_task: 10,
max_trials_in_block: 999999, criteria_fullfilled: 1, choosetask: 0,
roe:[false], /* repeat on error for each task */
trials:[],
current_trial:0,
start: function(){block_training.step=1; current_block="block_training";
this.trials = Array(10).fill( 0 );
this.trials = psy_array_shuffle( this.trials ) ;
this.trials = this.trials.slice(0,10);
psy_clear_stimulus_counters_db();block_training.run();},

run: function(){
current_block = block_training.blockname ; 
switch( block_training.step ){
case 1:
block_training.step++;
psy_add_text_rgb_db( 1, 0,-200, PSY_CENTRAL, PSY_CENTRAL, 0, 0, 0, "You see two numbers, one left and one right" , 0 );
psy_draw_all_db();
psy_add_text_rgb_db( 1, 0,-100, PSY_CENTRAL, PSY_CENTRAL, 0, 0, 0, "Look which number if physically largest" , 0 );
psy_draw_all_db();
psy_add_text_rgb_db( 1, 0,0, PSY_CENTRAL, PSY_CENTRAL, 0, 0, 0, "Press A if left number is physically larger" , 0 );
psy_draw_all_db();
psy_add_text_rgb_db( 1, 0,100, PSY_CENTRAL, PSY_CENTRAL, 0, 0, 0, "Press L if right number is physically larger" , 0 );
psy_draw_all_db();
psy_add_text_rgb_db( 1, 0,200, PSY_CENTRAL, PSY_CENTRAL, 0, 0, 0, "Click/tap anywhere to start" , 0 );
psy_draw_all_db();
psy_wait( 0, -1 );
break;
case 2:
block_training.step++;
psy_clear_screen_db();
block_training.run();
break;
case 3:
block_training.step++;
/*-- start the task part of the block -- */
/* First, make sure the screen is cleared */
psy_clear_screen_db();
block_training.max_trials_in_block=999999;
block_training.criteria_fullfilled=1;if( block_training.criteria_fullfilled > 0 && block_training.trial_counter <= block_training.max_trials_in_block){
block_training.trial_counter++;
this.current_trial = this.trials.shift();
task_sce.start( this.current_trial );
}else{setTimeout("block_training.run()",0)}
break;
case 4:
block_training.step++;
block_training.trial_counter_per_task--;
if ( error_status > 0 && this.trials.length > 0 && this.roe[0] ){this.trials.unshift( this.current_trial );this.trials.pop();}
if ( block_training.trials.length == 0 || block_training.trial_counter >= block_training.max_trials_in_block || tasklist_end_request == 1 || experiment_end_request == 1 ) { block_training.criteria_fullfilled = 0 ; tasklist_end_request = 0 ; }
if ( block_training.criteria_fullfilled == 1 ){ block_training.step=block_training.step-2 ; setTimeout("block_training.run()",0)
}else{setTimeout("block_training.run()",0)}
break;
case 5:
block_training.step++;
psy_clear_screen_db();
/* Feedback: Now check in all the trials of data file and get the information you need */
datalines = outputdata.split('\n');
var tmptrialcount=0;var tmplist=new Array();var tmpsum=0;var tmpmin=987654321;var tmpmax= -987654321;
for( tmpx = 0 ; tmpx < datalines.length - 1 ; tmpx++ ){ /* last line is empty */
datalinenumbers = datalines[tmpx].split(/ +/)
if ( parseInt(datalinenumbers[ 1 - 1 ]) == 1 & parseInt(datalinenumbers[ 3 - 1 ]) == 1 & parseInt(datalinenumbers[ 5 - 1 ]) == 1 ){
tmplist[tmptrialcount]=parseInt(datalinenumbers[ 3 ])
tmpsum = tmpsum + parseInt(datalinenumbers[ 3 ]);
if ( parseInt(datalinenumbers[ 3 ]) < tmpmin )tmpmin=parseInt(datalinenumbers[ 3 ]);
if ( parseInt(datalinenumbers[ 3 ]) > tmpmax )tmpmax=parseInt(datalinenumbers[ 3 ]);
tmptrialcount++ ;
}}
if ( tmptrialcount > 0 ) congruentTrials = Math.round( tmpsum / tmptrialcount ); else congruentTrials=0 ;
/* Feedback: Now check in all the trials of data file and get the information you need */
datalines = outputdata.split('\n');
var tmptrialcount=0;var tmplist=new Array();var tmpsum=0;var tmpmin=987654321;var tmpmax= -987654321;
for( tmpx = 0 ; tmpx < datalines.length - 1 ; tmpx++ ){ /* last line is empty */
datalinenumbers = datalines[tmpx].split(/ +/)
if ( parseInt(datalinenumbers[ 1 - 1 ]) == 1 & parseInt(datalinenumbers[ 3 - 1 ]) == 2 & parseInt(datalinenumbers[ 5 - 1 ]) == 1 ){
tmplist[tmptrialcount]=parseInt(datalinenumbers[ 3 ])
tmpsum = tmpsum + parseInt(datalinenumbers[ 3 ]);
if ( parseInt(datalinenumbers[ 3 ]) < tmpmin )tmpmin=parseInt(datalinenumbers[ 3 ]);
if ( parseInt(datalinenumbers[ 3 ]) > tmpmax )tmpmax=parseInt(datalinenumbers[ 3 ]);
tmptrialcount++ ;
}}
if ( tmptrialcount > 0 ) incongruentTrials = Math.round( tmpsum / tmptrialcount ); else incongruentTrials=0 ;
tmptext = "Congruent " + congruentTrials + "ms";
psy_add_text_rgb_db( 1 , -390 , -200 , PSY_CENTRAL,PSY_CENTRAL,0,0,0,tmptext , 1 );
psy_draw_all_db();
tmptext = "Incongruent " + incongruentTrials + "ms";
psy_add_text_rgb_db( 1 , -390 , -100 , PSY_CENTRAL,PSY_CENTRAL,0,0,0,tmptext , 1 );
psy_draw_all_db();
psy_add_text_rgb_db( 1 , -390 , 0 , PSY_CENTRAL , PSY_CENTRAL , 0,0,0 , "Click/tap to continue for real block" , 1 );
psy_draw_all_db();
psy_wait(0,-1);
/*-- end of the feedback part of the block -- */
break;
case 6:
block_training.step++;
psy_clear_screen_db();
setTimeout("blocks"+psy_blockorder+".run()",0)
break;
}}}
/* block name: real ----------------------- */
var block_real = {
blockname: "block_real", step: 1, trial_counter: 0,
trial_counter_per_task: 40,
max_trials_in_block: 999999, criteria_fullfilled: 1, choosetask: 0,
roe:[false], /* repeat on error for each task */
trials:[],
current_trial:0,
start: function(){block_real.step=1; current_block="block_real";
this.trials = Array(40).fill( 0 );
this.trials = psy_array_shuffle( this.trials ) ;
this.trials = this.trials.slice(0,40);
psy_clear_stimulus_counters_db();block_real.run();},

run: function(){
current_block = block_real.blockname ; 
switch( block_real.step ){
case 1:
block_real.step++;
psy_add_text_rgb_db( 1, 0,-200, PSY_CENTRAL, PSY_CENTRAL, 0, 0, 0, "The same task, but now for real" , 0 );
psy_draw_all_db();
psy_add_text_rgb_db( 1, 0,-100, PSY_CENTRAL, PSY_CENTRAL, 0, 0, 0, "Remember:" , 0 );
psy_draw_all_db();
psy_add_text_rgb_db( 1, 0,0, PSY_CENTRAL, PSY_CENTRAL, 0, 0, 0, "Press A if left number is physically larger" , 0 );
psy_draw_all_db();
psy_add_text_rgb_db( 1, 0,100, PSY_CENTRAL, PSY_CENTRAL, 0, 0, 0, "Press L if right number is physically larger" , 0 );
psy_draw_all_db();
psy_add_text_rgb_db( 1, 0,200, PSY_CENTRAL, PSY_CENTRAL, 0, 0, 0, "Click/tap anywhere to start" , 0 );
psy_draw_all_db();
psy_wait( 0, -1 );
break;
case 2:
block_real.step++;
psy_clear_screen_db();
block_real.run();
break;
case 3:
block_real.step++;
/*-- start the task part of the block -- */
/* First, make sure the screen is cleared */
psy_clear_screen_db();
block_real.max_trials_in_block=999999;
block_real.criteria_fullfilled=1;if( block_real.criteria_fullfilled > 0 && block_real.trial_counter <= block_real.max_trials_in_block){
block_real.trial_counter++;
this.current_trial = this.trials.shift();
task_sce.start( this.current_trial );
}else{setTimeout("block_real.run()",0)}
break;
case 4:
block_real.step++;
block_real.trial_counter_per_task--;
if ( error_status > 0 && this.trials.length > 0 && this.roe[0] ){this.trials.unshift( this.current_trial );this.trials.pop();}
if ( block_real.trials.length == 0 || block_real.trial_counter >= block_real.max_trials_in_block || tasklist_end_request == 1 || experiment_end_request == 1 ) { block_real.criteria_fullfilled = 0 ; tasklist_end_request = 0 ; }
if ( block_real.criteria_fullfilled == 1 ){ block_real.step=block_real.step-2 ; setTimeout("block_real.run()",0)
}else{setTimeout("block_real.run()",0)}
break;
case 5:
block_real.step++;
psy_clear_screen_db();
/* Feedback: Now check in all the trials of data file and get the information you need */
datalines = outputdata.split('\n');
var tmptrialcount=0;var tmplist=new Array();var tmpsum=0;var tmpmin=987654321;var tmpmax= -987654321;
for( tmpx = 0 ; tmpx < datalines.length - 1 ; tmpx++ ){ /* last line is empty */
datalinenumbers = datalines[tmpx].split(/ +/)
if ( parseInt(datalinenumbers[ 1 - 1 ]) == 2 & parseInt(datalinenumbers[ 3 - 1 ]) == 1 & parseInt(datalinenumbers[ 5 - 1 ]) == 1 ){
tmplist[tmptrialcount]=parseInt(datalinenumbers[ 3 ])
tmpsum = tmpsum + parseInt(datalinenumbers[ 3 ]);
if ( parseInt(datalinenumbers[ 3 ]) < tmpmin )tmpmin=parseInt(datalinenumbers[ 3 ]);
if ( parseInt(datalinenumbers[ 3 ]) > tmpmax )tmpmax=parseInt(datalinenumbers[ 3 ]);
tmptrialcount++ ;
}}
if ( tmptrialcount > 0 ) congruentTrials = Math.round( tmpsum / tmptrialcount ); else congruentTrials=0 ;
/* Feedback: Now check in all the trials of data file and get the information you need */
datalines = outputdata.split('\n');
var tmptrialcount=0;var tmplist=new Array();var tmpsum=0;var tmpmin=987654321;var tmpmax= -987654321;
for( tmpx = 0 ; tmpx < datalines.length - 1 ; tmpx++ ){ /* last line is empty */
datalinenumbers = datalines[tmpx].split(/ +/)
if ( parseInt(datalinenumbers[ 1 - 1 ]) == 2 & parseInt(datalinenumbers[ 3 - 1 ]) == 2 & parseInt(datalinenumbers[ 5 - 1 ]) == 1 ){
tmplist[tmptrialcount]=parseInt(datalinenumbers[ 3 ])
tmpsum = tmpsum + parseInt(datalinenumbers[ 3 ]);
if ( parseInt(datalinenumbers[ 3 ]) < tmpmin )tmpmin=parseInt(datalinenumbers[ 3 ]);
if ( parseInt(datalinenumbers[ 3 ]) > tmpmax )tmpmax=parseInt(datalinenumbers[ 3 ]);
tmptrialcount++ ;
}}
if ( tmptrialcount > 0 ) incongruentTrials = Math.round( tmpsum / tmptrialcount ); else incongruentTrials=0 ;
tmptext = "Congruent " + congruentTrials + "ms";
psy_add_text_rgb_db( 1 , -390 , -200 , PSY_CENTRAL,PSY_CENTRAL,0,0,0,tmptext , 1 );
psy_draw_all_db();
tmptext = "Incongruent " + incongruentTrials + "ms";
psy_add_text_rgb_db( 1 , -390 , -100 , PSY_CENTRAL,PSY_CENTRAL,0,0,0,tmptext , 1 );
psy_draw_all_db();
psy_add_text_rgb_db( 1 , -390 , 0 , PSY_CENTRAL , PSY_CENTRAL , 0,0,0 , "Click/tap to continue" , 1 );
psy_draw_all_db();
psy_wait(0,-1);
/*-- end of the feedback part of the block -- */
break;
case 6:
block_real.step++;
psy_clear_screen_db();
setTimeout("blocks"+psy_blockorder+".run()",0)
break;
}}}
var xhrcounter = 0;

function main(){
psy_screen_height = 600 ;
psy_screen_width = 800 ;
psy_screen_center_x = psy_screen_width / 2 ;
psy_screen_center_y = psy_screen_height / 2 ;
psy_frame_w = 800 ;
psy_frame_h = 600 ;
psy_screen_scale( 0 , false );
psy_canvas.focus();
psy_bgcol_r = 238 ;
psy_bgcol_g = 238 ;
psy_bgcol_b = 238 ;
psy_set_coordinate_system('c');
psy_exp_start_time = psy_exp_current_time = new Date().getTime();
psy_mouse_visibility( 1 );
/* centerzero: mean 0,0 is at the center of screen */
psy_load_font("Arial",30);
psy_load_font("Arial",100);
psy_load_font("Arial",120);

/* -- definition of block(s) -------------------------- */
when_stimuli_loaded_do("blocks"+psy_blockorder+".run()")}

/* -- calls to the blocks -------------------------------- */
var blocks1 = {blocknumber: 0,nblocks: 2 , run: function(){ blocks1.blocknumber++; switch ( blocks1.blocknumber ) {
case 1: block_training.start(); break;
case 2: block_real.start(); break;
case 3:
if( document.fullscreen ) psy_exit_fullscreen();
break;}}}
